# orbipay-paymentsapi-client
The Electronic Bill Presentment and Payments (EBPP) API enables businesses to accept bank account, credit and debit card payment


- API version: 1.13.0
- Package version: 1.13.0

## Requirements

PHP 5.5 and later

- "ext-curl": "*",
- "ext-json": "*"
- "ext-mbstring": "*",
- "guzzlehttp/guzzle": "^6.2"
- "lf4php/lf4php": "^4.2.2"

## Installation & Usage


### Manual Installation

1. Download the files
2. Add Following lines in your composer.json

```
     "repositories": [
         {
             "type": "path",
             "url": "/home/user/Downloads/orbipay-paymentsapi-client",
             "options": {
                 "symlink": false
             }
         }
     ]
```

For Example:

```json
 {
     "name": "example/client",
     "description": "example client",
     "require": {
         "php": ">=5.5",
         "ext-json": "*",
         "monolog/monolog": "1.23.*",
         "lf4php/lf4php-monolog": "^3.1.2",
         "orbipay/paymentsapi-client": "1.5.0"
     },
     "minimum-stability": "stable",
     "repositories": [
         {
             "type": "path",
             "url": "/home/user/Downloads/orbipay-paymentsapi-client",
             "options": {
                 "symlink": false
             }
         }
     ],
     "autoload": {
         "psr-4": {
             "MiniUpload\\": "src/"
         }
     } 
 }
```

```
composer install
```

### Logging
To see the logs Please [follow](https://packagist.org/packages/lf4php/lf4php).


### Timezone
You will need to specify your server's timezone before using this library. You can do this in your php.ini file:

date.timezone = 'America/Los_Angeles'
or in your PHP script:
date_default_timezone_set('America/Los_Angeles');

### Timeout
This library provides a way to configure the http_timeout through the environment variable '"ORBIPAY_PAYMENTS_API_TIMEOUT_SECONDS"'. For example in linux,
```shell
export ORBIPAY_PAYMENTS_API_TIMEOUT_SECONDS=60
```

## Author

support@billerpayments.com


