<?php



namespace Orbipay\PaymentsApi\Client\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;

/**
 * Warning:
 *
 * <p><font color="red"> This class subject to change without prior notice, Please dont use this class directly. </font></p>


 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Model
 */
class FundingAccountResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'FundingAccountResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'account_holder_name' => 'string',
        'nickname' => 'string',
        'address' => '\Orbipay\PaymentsApi\Client\Model\FundingAccountAddress',
        'account_number' => 'string',
        'aba_routing_number' => 'string',
        'issuer_name' => 'string',
        'currency_code3d' => 'string',
        'expiry_date' => 'string',
        'account_holder_type' => 'string',
        'custom_fields' => 'map[string,string]',
        'account_subtype' => 'string',
        'id' => 'string',
        'url' => 'string',
        'ach_eligible_flag' => 'string',
        'atm_eligible_flag' => 'string',
        'card_cvv_number' => 'string',
        'account_type' => 'string',
        'status' => 'string',
        'display_text' => 'string',
        'comments' => 'string',
        'audit_info' => '\Orbipay\PaymentsApi\Client\Model\AuditInfoVo'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'account_holder_name' => null,
        'nickname' => null,
        'address' => null,
        'account_number' => null,
        'aba_routing_number' => null,
        'issuer_name' => null,
        'currency_code3d' => null,
        'expiry_date' => null,
        'account_holder_type' => null,
        'custom_fields' => null,
        'account_subtype' => null,
        'id' => null,
        'url' => null,
        'ach_eligible_flag' => null,
        'atm_eligible_flag' => null,
        'card_cvv_number' => null,
        'account_type' => null,
        'status' => null,
        'display_text' => null,
        'comments' => null,
        'audit_info' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'account_holder_name' => 'account_holder_name',
        'nickname' => 'nickname',
        'address' => 'address',
        'account_number' => 'account_number',
        'aba_routing_number' => 'aba_routing_number',
        'issuer_name' => 'issuer_name',
        'currency_code3d' => 'currency_code3d',
        'expiry_date' => 'expiry_date',
        'account_holder_type' => 'account_holder_type',
        'custom_fields' => 'custom_fields',
        'account_subtype' => 'account_subtype',
        'id' => 'id',
        'url' => 'url',
        'ach_eligible_flag' => 'ach_eligible_flag',
        'atm_eligible_flag' => 'atm_eligible_flag',
        'card_cvv_number' => 'card_cvv_number',
        'account_type' => 'account_type',
        'status' => 'status',
        'display_text' => 'display_text',
        'comments' => 'comments',
        'audit_info' => 'audit_info'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'account_holder_name' => 'setAccountHolderName',
        'nickname' => 'setNickname',
        'address' => 'setAddress',
        'account_number' => 'setAccountNumber',
        'aba_routing_number' => 'setAbaRoutingNumber',
        'issuer_name' => 'setIssuerName',
        'currency_code3d' => 'setCurrencyCode3d',
        'expiry_date' => 'setExpiryDate',
        'account_holder_type' => 'setAccountHolderType',
        'custom_fields' => 'setCustomFields',
        'account_subtype' => 'setAccountSubtype',
        'id' => 'setId',
        'url' => 'setUrl',
        'ach_eligible_flag' => 'setAchEligibleFlag',
        'atm_eligible_flag' => 'setAtmEligibleFlag',
        'card_cvv_number' => 'setCardCvvNumber',
        'account_type' => 'setAccountType',
        'status' => 'setStatus',
        'display_text' => 'setDisplayText',
        'comments' => 'setComments',
        'audit_info' => 'setAuditInfo'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'account_holder_name' => 'getAccountHolderName',
        'nickname' => 'getNickname',
        'address' => 'getAddress',
        'account_number' => 'getAccountNumber',
        'aba_routing_number' => 'getAbaRoutingNumber',
        'issuer_name' => 'getIssuerName',
        'currency_code3d' => 'getCurrencyCode3d',
        'expiry_date' => 'getExpiryDate',
        'account_holder_type' => 'getAccountHolderType',
        'custom_fields' => 'getCustomFields',
        'account_subtype' => 'getAccountSubtype',
        'id' => 'getId',
        'url' => 'getUrl',
        'ach_eligible_flag' => 'getAchEligibleFlag',
        'atm_eligible_flag' => 'getAtmEligibleFlag',
        'card_cvv_number' => 'getCardCvvNumber',
        'account_type' => 'getAccountType',
        'status' => 'getStatus',
        'display_text' => 'getDisplayText',
        'comments' => 'getComments',
        'audit_info' => 'getAuditInfo'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const ACCOUNT_HOLDER_TYPE_PERSONAL = 'personal';
    const ACCOUNT_HOLDER_TYPE_BUSINESS = 'business';
    const ACCOUNT_SUBTYPE_SAVINGS = 'savings';
    const ACCOUNT_SUBTYPE_CHECKING = 'checking';
    const ACCOUNT_SUBTYPE_MONEY_MARKET = 'money_market';
    const ACCOUNT_SUBTYPE_VISA_CREDIT = 'visa_credit';
    const ACCOUNT_SUBTYPE_MASTERCARD_CREDIT = 'mastercard_credit';
    const ACCOUNT_SUBTYPE_AMERICAN_EXPRESS_CREDIT = 'american_express_credit';
    const ACCOUNT_SUBTYPE_DISCOVER_CREDIT = 'discover_credit';
    const ACCOUNT_SUBTYPE_VISA_DEBIT = 'visa_debit';
    const ACCOUNT_SUBTYPE_MASTERCARD_DEBIT = 'mastercard_debit';
    const ACCOUNT_SUBTYPE_DISCOVER_DEBIT = 'discover_debit';
    const ACCOUNT_SUBTYPE_APPLE_PAY = 'apple_pay';
    const ACCOUNT_SUBTYPE_GOOGLE_PAY = 'google_pay';
    const ACCOUNT_SUBTYPE_VOYAGER_FLEET = 'voyager_fleet';
    const ACH_ELIGIBLE_FLAG_YES = 'yes';
    const ACH_ELIGIBLE_FLAG_NO = 'no';
    const ATM_ELIGIBLE_FLAG_YES = 'yes';
    const ATM_ELIGIBLE_FLAG_NO = 'no';
    const ACCOUNT_TYPE_BANK = 'bank';
    const ACCOUNT_TYPE_DEBIT_CARD = 'debit_card';
    const ACCOUNT_TYPE_CREDIT_CARD = 'credit_card';
    const ACCOUNT_TYPE_WALLET = 'wallet';
    const ACCOUNT_TYPE_CLOSED_LOOP = 'closed_loop';
    const STATUS_ACTIVE = 'active';
    const STATUS_INACTIVE = 'inactive';
    const STATUS_FROZEN = 'frozen';
    const STATUS_UNVERIFIED = 'unverified';
    const STATUS_UNUSABLE = 'unusable';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAccountHolderTypeAllowableValues()
    {
        return [
            self::ACCOUNT_HOLDER_TYPE_PERSONAL,
            self::ACCOUNT_HOLDER_TYPE_BUSINESS,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAccountSubtypeAllowableValues()
    {
        return [
            self::ACCOUNT_SUBTYPE_SAVINGS,
            self::ACCOUNT_SUBTYPE_CHECKING,
            self::ACCOUNT_SUBTYPE_MONEY_MARKET,
            self::ACCOUNT_SUBTYPE_VISA_CREDIT,
            self::ACCOUNT_SUBTYPE_MASTERCARD_CREDIT,
            self::ACCOUNT_SUBTYPE_AMERICAN_EXPRESS_CREDIT,
            self::ACCOUNT_SUBTYPE_DISCOVER_CREDIT,
            self::ACCOUNT_SUBTYPE_VISA_DEBIT,
            self::ACCOUNT_SUBTYPE_MASTERCARD_DEBIT,
            self::ACCOUNT_SUBTYPE_DISCOVER_DEBIT,
            self::ACCOUNT_SUBTYPE_APPLE_PAY,
            self::ACCOUNT_SUBTYPE_GOOGLE_PAY,
            self::ACCOUNT_SUBTYPE_VOYAGER_FLEET,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAchEligibleFlagAllowableValues()
    {
        return [
            self::ACH_ELIGIBLE_FLAG_YES,
            self::ACH_ELIGIBLE_FLAG_NO,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAtmEligibleFlagAllowableValues()
    {
        return [
            self::ATM_ELIGIBLE_FLAG_YES,
            self::ATM_ELIGIBLE_FLAG_NO,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAccountTypeAllowableValues()
    {
        return [
            self::ACCOUNT_TYPE_BANK,
            self::ACCOUNT_TYPE_DEBIT_CARD,
            self::ACCOUNT_TYPE_CREDIT_CARD,
            self::ACCOUNT_TYPE_WALLET,
            self::ACCOUNT_TYPE_CLOSED_LOOP,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_ACTIVE,
            self::STATUS_INACTIVE,
            self::STATUS_FROZEN,
            self::STATUS_UNVERIFIED,
            self::STATUS_UNUSABLE,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['account_holder_name'] = isset($data['account_holder_name']) ? $data['account_holder_name'] : null;
        $this->container['nickname'] = isset($data['nickname']) ? $data['nickname'] : null;
        $this->container['address'] = isset($data['address']) ? $data['address'] : null;
        $this->container['account_number'] = isset($data['account_number']) ? $data['account_number'] : null;
        $this->container['aba_routing_number'] = isset($data['aba_routing_number']) ? $data['aba_routing_number'] : null;
        $this->container['issuer_name'] = isset($data['issuer_name']) ? $data['issuer_name'] : null;
        $this->container['currency_code3d'] = isset($data['currency_code3d']) ? $data['currency_code3d'] : null;
        $this->container['expiry_date'] = isset($data['expiry_date']) ? $data['expiry_date'] : null;
        $this->container['account_holder_type'] = isset($data['account_holder_type']) ? $data['account_holder_type'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
        $this->container['account_subtype'] = isset($data['account_subtype']) ? $data['account_subtype'] : null;
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['ach_eligible_flag'] = isset($data['ach_eligible_flag']) ? $data['ach_eligible_flag'] : null;
        $this->container['atm_eligible_flag'] = isset($data['atm_eligible_flag']) ? $data['atm_eligible_flag'] : null;
        $this->container['card_cvv_number'] = isset($data['card_cvv_number']) ? $data['card_cvv_number'] : null;
        $this->container['account_type'] = isset($data['account_type']) ? $data['account_type'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['display_text'] = isset($data['display_text']) ? $data['display_text'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['audit_info'] = isset($data['audit_info']) ? $data['audit_info'] : null;
    }


    /**
     * Gets account_holder_name
     *
     * @return string
     */
    public function getAccountHolderName()
    {
        return $this->container['account_holder_name'];
    }

    /**
     * Sets account_holder_name
     *
     * @param string $account_holder_name The name as specified on the account.
     *
     * @return $this
     */
    public function setAccountHolderName($account_holder_name)
    {
        $this->container['account_holder_name'] = $account_holder_name;

        return $this;
    }

    /**
     * Gets nickname
     *
     * @return string
     */
    public function getNickname()
    {
        return $this->container['nickname'];
    }

    /**
     * Sets nickname
     *
     * @param string $nickname The nickname by which a customer might want to identify the account.
     *
     * @return $this
     */
    public function setNickname($nickname)
    {
        $this->container['nickname'] = $nickname;

        return $this;
    }

    /**
     * Gets address
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FundingAccountAddress
     */
    public function getAddress()
    {
        return $this->container['address'];
    }

    /**
     * Sets address
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FundingAccountAddress $address address
     *
     * @return $this
     */
    public function setAddress($address)
    {
        $this->container['address'] = $address;

        return $this;
    }

    /**
     * Gets account_number
     *
     * @return string
     */
    public function getAccountNumber()
    {
        return $this->container['account_number'];
    }

    /**
     * Sets account_number
     *
     * @param string $account_number The number or reference that a customer uses to identify the funding account. In case of Apple Pay, this is the device-specific account number of the card.
     *
     * @return $this
     */
    public function setAccountNumber($account_number)
    {
        $this->container['account_number'] = $account_number;

        return $this;
    }

    /**
     * Gets aba_routing_number
     *
     * @return string
     */
    public function getAbaRoutingNumber()
    {
        return $this->container['aba_routing_number'];
    }

    /**
     * Sets aba_routing_number
     *
     * @param string $aba_routing_number The ABA/Routing number for the bank account.
     *
     * @return $this
     */
    public function setAbaRoutingNumber($aba_routing_number)
    {
        $this->container['aba_routing_number'] = $aba_routing_number;

        return $this;
    }

    /**
     * Gets issuer_name
     *
     * @return string
     */
    public function getIssuerName()
    {
        return $this->container['issuer_name'];
    }

    /**
     * Sets issuer_name
     *
     * @param string $issuer_name The name of the authority that has issued the account. This is relevant only in the case of bank accounts.
     *
     * @return $this
     */
    public function setIssuerName($issuer_name)
    {
        $this->container['issuer_name'] = $issuer_name;

        return $this;
    }

    /**
     * Gets currency_code3d
     *
     * @return string
     */
    public function getCurrencyCode3d()
    {
        return $this->container['currency_code3d'];
    }

    /**
     * Sets currency_code3d
     *
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.
     *
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->container['currency_code3d'] = $currency_code3d;

        return $this;
    }

    /**
     * Gets expiry_date
     *
     * @return string
     */
    public function getExpiryDate()
    {
        return $this->container['expiry_date'];
    }

    /**
     * Sets expiry_date
     *
     * @param string $expiry_date The expiry date for the card. This is to be in the format MM/YY.
     *
     * @return $this
     */
    public function setExpiryDate($expiry_date)
    {
        $this->container['expiry_date'] = $expiry_date;

        return $this;
    }

    /**
     * Gets account_holder_type
     *
     * @return string
     */
    public function getAccountHolderType()
    {
        return $this->container['account_holder_type'];
    }

    /**
     * Sets account_holder_type
     *
     * @param string $account_holder_type The type of ownership for the funding account. This is applicable only in the case of bank accounts and it is defaults to personal.
     *
     * @return $this
     */
    public function setAccountHolderType($account_holder_type)
    {
        $this->container['account_holder_type'] = $account_holder_type;

        return $this;
    }

    /**
     * Gets custom_fields
     *
     * @return map[string,string]
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     *
     * @param map[string,string] $custom_fields The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.
     *
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Gets account_subtype
     *
     * @return string
     */
    public function getAccountSubtype()
    {
        return $this->container['account_subtype'];
    }

    /**
     * Sets account_subtype
     *
     * @param string $account_subtype The sub type of the funding account. This is derived by EBPP in the case of card funding accounts. It needs to be passed when adding or editing a DDA/Bank/ApplePay/GooglePay/Voyager account.
     *
     * @return $this
     */
    public function setAccountSubtype($account_subtype)
    {
        $this->container['account_subtype'] = $account_subtype;

        return $this;
    }

    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id Id is a unique identifier assigned to the funding account in EBPP. A new Id is generated for the funding account when the account number is updated.
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url This URL fetches the funding account details.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets ach_eligible_flag
     *
     * @return string
     */
    public function getAchEligibleFlag()
    {
        return $this->container['ach_eligible_flag'];
    }

    /**
     * Sets ach_eligible_flag
     *
     * @param string $ach_eligible_flag Indicates if the funding account can be debited vide ACH, in case the funding account is a Demand Deposit Account (DDA).
     *
     * @return $this
     */
    public function setAchEligibleFlag($ach_eligible_flag)
    {
        $this->container['ach_eligible_flag'] = $ach_eligible_flag;

        return $this;
    }

    /**
     * Gets atm_eligible_flag
     *
     * @return string
     */
    public function getAtmEligibleFlag()
    {
        return $this->container['atm_eligible_flag'];
    }

    /**
     * Sets atm_eligible_flag
     *
     * @param string $atm_eligible_flag Indicates if the funding account can be debited vide the ATM Rail network, in case the funding account is a Debit Card.
     *
     * @return $this
     */
    public function setAtmEligibleFlag($atm_eligible_flag)
    {
        $this->container['atm_eligible_flag'] = $atm_eligible_flag;

        return $this;
    }

    /**
     * Gets card_cvv_number
     *
     * @return string
     */
    public function getCardCvvNumber()
    {
        return $this->container['card_cvv_number'];
    }

    /**
     * Sets card_cvv_number
     *
     * @param string $card_cvv_number This is never returned by EBPP. This needs to be passed to EBPP when adding or editing a card funding account.
     *
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->container['card_cvv_number'] = $card_cvv_number;

        return $this;
    }

    /**
     * Gets account_type
     *
     * @return string
     */
    public function getAccountType()
    {
        return $this->container['account_type'];
    }

    /**
     * Sets account_type
     *
     * @param string $account_type The type of the funding account.
     *
     * @return $this
     */
    public function setAccountType($account_type)
    {
        $this->container['account_type'] = $account_type;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status The status of the funding account in EBPP.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets display_text
     *
     * @return string
     */
    public function getDisplayText()
    {
        return $this->container['display_text'];
    }

    /**
     * Sets display_text
     *
     * @param string $display_text UI representation of the account.
     *
     * @return $this
     */
    public function setDisplayText($display_text)
    {
        $this->container['display_text'] = $display_text;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets audit_info
     *
     * @return \Orbipay\PaymentsApi\Client\Model\AuditInfoVo
     */
    public function getAuditInfo()
    {
        return $this->container['audit_info'];
    }

    /**
     * Sets audit_info
     *
     * @param \Orbipay\PaymentsApi\Client\Model\AuditInfoVo $audit_info audit_info
     *
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->container['audit_info'] = $audit_info;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


