<?php



namespace Orbipay\PaymentsApi\Client\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;

/**
 * Warning:
 *
 * <p><font color="red"> This class subject to change without prior notice, Please dont use this class directly. </font></p>


 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Model
 */
class PaymentSetupResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'PaymentSetupResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'string',
        'url' => 'string',
        'fee' => '\Orbipay\PaymentsApi\Client\Model\FeeResponse',
        'status' => 'string',
        'payment_method' => 'string',
        'payment_setup_schedule_type' => 'string',
        'confirmation_number' => 'string',
        'custom_fields' => 'map[string,string]',
        'currency_code3d' => 'string',
        'amount' => 'string',
        'card_cvv_number' => 'string',
        'next_payment_date' => 'string',
        'payment_setup_reference' => 'string',
        'payment_schedule' => '\Orbipay\PaymentsApi\Client\Model\PaymentScheduleVo',
        'payment_setup_entry_date' => 'string',
        'comments' => 'string',
        'customer' => '\Orbipay\PaymentsApi\Client\Model\CustomerSnapshotResponse',
        'funding_account' => '\Orbipay\PaymentsApi\Client\Model\FundingAccountSnapshotResponse',
        'customer_account' => '\Orbipay\PaymentsApi\Client\Model\CustomerAccountSnapshotResponse',
        'payment_network_response' => '\Orbipay\PaymentsApi\Client\Model\PaymentNetworkResponseVo',
        'audit_info' => '\Orbipay\PaymentsApi\Client\Model\AuditInfoVo'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'id' => null,
        'url' => null,
        'fee' => null,
        'status' => null,
        'payment_method' => null,
        'payment_setup_schedule_type' => null,
        'confirmation_number' => null,
        'custom_fields' => null,
        'currency_code3d' => null,
        'amount' => null,
        'card_cvv_number' => null,
        'next_payment_date' => null,
        'payment_setup_reference' => null,
        'payment_schedule' => null,
        'payment_setup_entry_date' => null,
        'comments' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'payment_network_response' => null,
        'audit_info' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'url' => 'url',
        'fee' => 'fee',
        'status' => 'status',
        'payment_method' => 'payment_method',
        'payment_setup_schedule_type' => 'payment_setup_schedule_type',
        'confirmation_number' => 'confirmation_number',
        'custom_fields' => 'custom_fields',
        'currency_code3d' => 'currency_code3d',
        'amount' => 'amount',
        'card_cvv_number' => 'card_cvv_number',
        'next_payment_date' => 'next_payment_date',
        'payment_setup_reference' => 'payment_setup_reference',
        'payment_schedule' => 'payment_schedule',
        'payment_setup_entry_date' => 'payment_setup_entry_date',
        'comments' => 'comments',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'payment_network_response' => 'payment_network_response',
        'audit_info' => 'audit_info'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'url' => 'setUrl',
        'fee' => 'setFee',
        'status' => 'setStatus',
        'payment_method' => 'setPaymentMethod',
        'payment_setup_schedule_type' => 'setPaymentSetupScheduleType',
        'confirmation_number' => 'setConfirmationNumber',
        'custom_fields' => 'setCustomFields',
        'currency_code3d' => 'setCurrencyCode3d',
        'amount' => 'setAmount',
        'card_cvv_number' => 'setCardCvvNumber',
        'next_payment_date' => 'setNextPaymentDate',
        'payment_setup_reference' => 'setPaymentSetupReference',
        'payment_schedule' => 'setPaymentSchedule',
        'payment_setup_entry_date' => 'setPaymentSetupEntryDate',
        'comments' => 'setComments',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'payment_network_response' => 'setPaymentNetworkResponse',
        'audit_info' => 'setAuditInfo'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'url' => 'getUrl',
        'fee' => 'getFee',
        'status' => 'getStatus',
        'payment_method' => 'getPaymentMethod',
        'payment_setup_schedule_type' => 'getPaymentSetupScheduleType',
        'confirmation_number' => 'getConfirmationNumber',
        'custom_fields' => 'getCustomFields',
        'currency_code3d' => 'getCurrencyCode3d',
        'amount' => 'getAmount',
        'card_cvv_number' => 'getCardCvvNumber',
        'next_payment_date' => 'getNextPaymentDate',
        'payment_setup_reference' => 'getPaymentSetupReference',
        'payment_schedule' => 'getPaymentSchedule',
        'payment_setup_entry_date' => 'getPaymentSetupEntryDate',
        'comments' => 'getComments',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'payment_network_response' => 'getPaymentNetworkResponse',
        'audit_info' => 'getAuditInfo'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const STATUS_SCHEDULED = 'scheduled';
    const STATUS_CANCELLED = 'cancelled';
    const STATUS_DECLINED = 'declined';
    const STATUS_ERROR = 'error';
    const STATUS_COMPLETED = 'completed';
    const PAYMENT_METHOD_ACH = 'ach';
    const PAYMENT_METHOD_VISA_DEBIT = 'visa_debit';
    const PAYMENT_METHOD_PINLESS_DEBIT = 'pinless_debit';
    const PAYMENT_METHOD_MASTER_DEBIT = 'master_debit';
    const PAYMENT_METHOD_AMEX_CREDIT = 'amex_credit';
    const PAYMENT_METHOD_DISCOVER_CREDIT = 'discover_credit';
    const PAYMENT_METHOD_VISA_CREDIT = 'visa_credit';
    const PAYMENT_METHOD_MASTER_CREDIT = 'master_credit';
    const PAYMENT_METHOD_DISCOVER_DEBIT = 'discover_debit';
    const PAYMENT_SETUP_SCHEDULE_TYPE_VARIABLE_RECURRING_ENROLLMENT = 'variable_recurring_enrollment';
    const PAYMENT_SETUP_SCHEDULE_TYPE_AUTOPAY_ENROLLMENT = 'autopay_enrollment';
    const PAYMENT_SETUP_SCHEDULE_TYPE_PAYMENT_PLAN = 'payment_plan';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_SCHEDULED,
            self::STATUS_CANCELLED,
            self::STATUS_DECLINED,
            self::STATUS_ERROR,
            self::STATUS_COMPLETED,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentMethodAllowableValues()
    {
        return [
            self::PAYMENT_METHOD_ACH,
            self::PAYMENT_METHOD_VISA_DEBIT,
            self::PAYMENT_METHOD_PINLESS_DEBIT,
            self::PAYMENT_METHOD_MASTER_DEBIT,
            self::PAYMENT_METHOD_AMEX_CREDIT,
            self::PAYMENT_METHOD_DISCOVER_CREDIT,
            self::PAYMENT_METHOD_VISA_CREDIT,
            self::PAYMENT_METHOD_MASTER_CREDIT,
            self::PAYMENT_METHOD_DISCOVER_DEBIT,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentSetupScheduleTypeAllowableValues()
    {
        return [
            self::PAYMENT_SETUP_SCHEDULE_TYPE_VARIABLE_RECURRING_ENROLLMENT,
            self::PAYMENT_SETUP_SCHEDULE_TYPE_AUTOPAY_ENROLLMENT,
            self::PAYMENT_SETUP_SCHEDULE_TYPE_PAYMENT_PLAN,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['fee'] = isset($data['fee']) ? $data['fee'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['payment_method'] = isset($data['payment_method']) ? $data['payment_method'] : null;
        $this->container['payment_setup_schedule_type'] = isset($data['payment_setup_schedule_type']) ? $data['payment_setup_schedule_type'] : null;
        $this->container['confirmation_number'] = isset($data['confirmation_number']) ? $data['confirmation_number'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
        $this->container['currency_code3d'] = isset($data['currency_code3d']) ? $data['currency_code3d'] : null;
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['card_cvv_number'] = isset($data['card_cvv_number']) ? $data['card_cvv_number'] : null;
        $this->container['next_payment_date'] = isset($data['next_payment_date']) ? $data['next_payment_date'] : null;
        $this->container['payment_setup_reference'] = isset($data['payment_setup_reference']) ? $data['payment_setup_reference'] : null;
        $this->container['payment_schedule'] = isset($data['payment_schedule']) ? $data['payment_schedule'] : null;
        $this->container['payment_setup_entry_date'] = isset($data['payment_setup_entry_date']) ? $data['payment_setup_entry_date'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['customer'] = isset($data['customer']) ? $data['customer'] : null;
        $this->container['funding_account'] = isset($data['funding_account']) ? $data['funding_account'] : null;
        $this->container['customer_account'] = isset($data['customer_account']) ? $data['customer_account'] : null;
        $this->container['payment_network_response'] = isset($data['payment_network_response']) ? $data['payment_network_response'] : null;
        $this->container['audit_info'] = isset($data['audit_info']) ? $data['audit_info'] : null;
    }


    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id The unique identifier assigned by EBPP to the payment setup.
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url This URL fetches the details of payment setup.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets fee
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FeeResponse
     */
    public function getFee()
    {
        return $this->container['fee'];
    }

    /**
     * Sets fee
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FeeResponse $fee fee
     *
     * @return $this
     */
    public function setFee($fee)
    {
        $this->container['fee'] = $fee;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status The status of the payment.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets payment_method
     *
     * @return string
     */
    public function getPaymentMethod()
    {
        return $this->container['payment_method'];
    }

    /**
     * Sets payment_method
     *
     * @param string $payment_method The fulfillment method for the payment.
     *
     * @return $this
     */
    public function setPaymentMethod($payment_method)
    {
        $this->container['payment_method'] = $payment_method;

        return $this;
    }

    /**
     * Gets payment_setup_schedule_type
     *
     * @return string
     */
    public function getPaymentSetupScheduleType()
    {
        return $this->container['payment_setup_schedule_type'];
    }

    /**
     * Sets payment_setup_schedule_type
     *
     * @param string $payment_setup_schedule_type The schedule type for the payment setup.
     *
     * @return $this
     */
    public function setPaymentSetupScheduleType($payment_setup_schedule_type)
    {
        $this->container['payment_setup_schedule_type'] = $payment_setup_schedule_type;

        return $this;
    }

    /**
     * Gets confirmation_number
     *
     * @return string
     */
    public function getConfirmationNumber()
    {
        return $this->container['confirmation_number'];
    }

    /**
     * Sets confirmation_number
     *
     * @param string $confirmation_number The confirmation number or reference provided to the customer for the payment setup.
     *
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        $this->container['confirmation_number'] = $confirmation_number;

        return $this;
    }

    /**
     * Gets custom_fields
     *
     * @return map[string,string]
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     *
     * @param map[string,string] $custom_fields The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.
     *
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Gets currency_code3d
     *
     * @return string
     */
    public function getCurrencyCode3d()
    {
        return $this->container['currency_code3d'];
    }

    /**
     * Sets currency_code3d
     *
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.
     *
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->container['currency_code3d'] = $currency_code3d;

        return $this;
    }

    /**
     * Gets amount
     *
     * @return string
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     *
     * @param string $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     *
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets card_cvv_number
     *
     * @return string
     */
    public function getCardCvvNumber()
    {
        return $this->container['card_cvv_number'];
    }

    /**
     * Sets card_cvv_number
     *
     * @param string $card_cvv_number This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment setup with a card funding account.
     *
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->container['card_cvv_number'] = $card_cvv_number;

        return $this;
    }

    /**
     * Gets next_payment_date
     *
     * @return string
     */
    public function getNextPaymentDate()
    {
        return $this->container['next_payment_date'];
    }

    /**
     * Sets next_payment_date
     *
     * @param string $next_payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setNextPaymentDate($next_payment_date)
    {
        $this->container['next_payment_date'] = $next_payment_date;

        return $this;
    }

    /**
     * Gets payment_setup_reference
     *
     * @return string
     */
    public function getPaymentSetupReference()
    {
        return $this->container['payment_setup_reference'];
    }

    /**
     * Sets payment_setup_reference
     *
     * @param string $payment_setup_reference The unique identifier in the client system for the payment setup.
     *
     * @return $this
     */
    public function setPaymentSetupReference($payment_setup_reference)
    {
        $this->container['payment_setup_reference'] = $payment_setup_reference;

        return $this;
    }

    /**
     * Gets payment_schedule
     *
     * @return \Orbipay\PaymentsApi\Client\Model\PaymentScheduleVo
     */
    public function getPaymentSchedule()
    {
        return $this->container['payment_schedule'];
    }

    /**
     * Sets payment_schedule
     *
     * @param \Orbipay\PaymentsApi\Client\Model\PaymentScheduleVo $payment_schedule payment_schedule
     *
     * @return $this
     */
    public function setPaymentSchedule($payment_schedule)
    {
        $this->container['payment_schedule'] = $payment_schedule;

        return $this;
    }

    /**
     * Gets payment_setup_entry_date
     *
     * @return string
     */
    public function getPaymentSetupEntryDate()
    {
        return $this->container['payment_setup_entry_date'];
    }

    /**
     * Sets payment_setup_entry_date
     *
     * @param string $payment_setup_entry_date The date on which the payment setup is captured in EBPP. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentSetupEntryDate($payment_setup_entry_date)
    {
        $this->container['payment_setup_entry_date'] = $payment_setup_entry_date;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Model\CustomerSnapshotResponse
     */
    public function getCustomer()
    {
        return $this->container['customer'];
    }

    /**
     * Sets customer
     *
     * @param \Orbipay\PaymentsApi\Client\Model\CustomerSnapshotResponse $customer customer
     *
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->container['customer'] = $customer;

        return $this;
    }

    /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FundingAccountSnapshotResponse
     */
    public function getFundingAccount()
    {
        return $this->container['funding_account'];
    }

    /**
     * Sets funding_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FundingAccountSnapshotResponse $funding_account funding_account
     *
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->container['funding_account'] = $funding_account;

        return $this;
    }

    /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\CustomerAccountSnapshotResponse
     */
    public function getCustomerAccount()
    {
        return $this->container['customer_account'];
    }

    /**
     * Sets customer_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\CustomerAccountSnapshotResponse $customer_account customer_account
     *
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->container['customer_account'] = $customer_account;

        return $this;
    }

    /**
     * Gets payment_network_response
     *
     * @return \Orbipay\PaymentsApi\Client\Model\PaymentNetworkResponseVo
     */
    public function getPaymentNetworkResponse()
    {
        return $this->container['payment_network_response'];
    }

    /**
     * Sets payment_network_response
     *
     * @param \Orbipay\PaymentsApi\Client\Model\PaymentNetworkResponseVo $payment_network_response payment_network_response
     *
     * @return $this
     */
    public function setPaymentNetworkResponse($payment_network_response)
    {
        $this->container['payment_network_response'] = $payment_network_response;

        return $this;
    }

    /**
     * Gets audit_info
     *
     * @return \Orbipay\PaymentsApi\Client\Model\AuditInfoVo
     */
    public function getAuditInfo()
    {
        return $this->container['audit_info'];
    }

    /**
     * Sets audit_info
     *
     * @param \Orbipay\PaymentsApi\Client\Model\AuditInfoVo $audit_info audit_info
     *
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->container['audit_info'] = $audit_info;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


