<?php



namespace Orbipay\PaymentsApi\Client\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;

/**
 * Warning:
 *
 * <p><font color="red"> This class subject to change without prior notice, Please dont use this class directly. </font></p>


 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Model
 */
class RecordPaymentCustomerAccountRequest implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'RecordPaymentCustomerAccountRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'account_holder_name' => 'string',
        'nickname' => 'string',
        'address' => '\Orbipay\PaymentsApi\Client\Model\AddressVo',
        'customer_account_reference' => 'string',
        'account_number' => 'string',
        'current_balance' => 'string',
        'current_statement_balance' => 'string',
        'minimum_payment_due' => 'string',
        'past_amount_due' => 'string',
        'payment_due_date' => 'string',
        'statement_date' => 'string',
        'custom_fields' => 'map[string,string]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'account_holder_name' => null,
        'nickname' => null,
        'address' => null,
        'customer_account_reference' => null,
        'account_number' => null,
        'current_balance' => null,
        'current_statement_balance' => null,
        'minimum_payment_due' => null,
        'past_amount_due' => null,
        'payment_due_date' => null,
        'statement_date' => null,
        'custom_fields' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'account_holder_name' => 'account_holder_name',
        'nickname' => 'nickname',
        'address' => 'address',
        'customer_account_reference' => 'customer_account_reference',
        'account_number' => 'account_number',
        'current_balance' => 'current_balance',
        'current_statement_balance' => 'current_statement_balance',
        'minimum_payment_due' => 'minimum_payment_due',
        'past_amount_due' => 'past_amount_due',
        'payment_due_date' => 'payment_due_date',
        'statement_date' => 'statement_date',
        'custom_fields' => 'custom_fields'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'account_holder_name' => 'setAccountHolderName',
        'nickname' => 'setNickname',
        'address' => 'setAddress',
        'customer_account_reference' => 'setCustomerAccountReference',
        'account_number' => 'setAccountNumber',
        'current_balance' => 'setCurrentBalance',
        'current_statement_balance' => 'setCurrentStatementBalance',
        'minimum_payment_due' => 'setMinimumPaymentDue',
        'past_amount_due' => 'setPastAmountDue',
        'payment_due_date' => 'setPaymentDueDate',
        'statement_date' => 'setStatementDate',
        'custom_fields' => 'setCustomFields'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'account_holder_name' => 'getAccountHolderName',
        'nickname' => 'getNickname',
        'address' => 'getAddress',
        'customer_account_reference' => 'getCustomerAccountReference',
        'account_number' => 'getAccountNumber',
        'current_balance' => 'getCurrentBalance',
        'current_statement_balance' => 'getCurrentStatementBalance',
        'minimum_payment_due' => 'getMinimumPaymentDue',
        'past_amount_due' => 'getPastAmountDue',
        'payment_due_date' => 'getPaymentDueDate',
        'statement_date' => 'getStatementDate',
        'custom_fields' => 'getCustomFields'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['account_holder_name'] = isset($data['account_holder_name']) ? $data['account_holder_name'] : null;
        $this->container['nickname'] = isset($data['nickname']) ? $data['nickname'] : null;
        $this->container['address'] = isset($data['address']) ? $data['address'] : null;
        $this->container['customer_account_reference'] = isset($data['customer_account_reference']) ? $data['customer_account_reference'] : null;
        $this->container['account_number'] = isset($data['account_number']) ? $data['account_number'] : null;
        $this->container['current_balance'] = isset($data['current_balance']) ? $data['current_balance'] : null;
        $this->container['current_statement_balance'] = isset($data['current_statement_balance']) ? $data['current_statement_balance'] : null;
        $this->container['minimum_payment_due'] = isset($data['minimum_payment_due']) ? $data['minimum_payment_due'] : null;
        $this->container['past_amount_due'] = isset($data['past_amount_due']) ? $data['past_amount_due'] : null;
        $this->container['payment_due_date'] = isset($data['payment_due_date']) ? $data['payment_due_date'] : null;
        $this->container['statement_date'] = isset($data['statement_date']) ? $data['statement_date'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
    }


    /**
     * Gets account_holder_name
     *
     * @return string
     */
    public function getAccountHolderName()
    {
        return $this->container['account_holder_name'];
    }

    /**
     * Sets account_holder_name
     *
     * @param string $account_holder_name The name as specified on the account.
     *
     * @return $this
     */
    public function setAccountHolderName($account_holder_name)
    {
        $this->container['account_holder_name'] = $account_holder_name;

        return $this;
    }

    /**
     * Gets nickname
     *
     * @return string
     */
    public function getNickname()
    {
        return $this->container['nickname'];
    }

    /**
     * Sets nickname
     *
     * @param string $nickname The nickname by which a customer might want to identify the account.
     *
     * @return $this
     */
    public function setNickname($nickname)
    {
        $this->container['nickname'] = $nickname;

        return $this;
    }

    /**
     * Gets address
     *
     * @return \Orbipay\PaymentsApi\Client\Model\AddressVo
     */
    public function getAddress()
    {
        return $this->container['address'];
    }

    /**
     * Sets address
     *
     * @param \Orbipay\PaymentsApi\Client\Model\AddressVo $address address
     *
     * @return $this
     */
    public function setAddress($address)
    {
        $this->container['address'] = $address;

        return $this;
    }

    /**
     * Gets customer_account_reference
     *
     * @return string
     */
    public function getCustomerAccountReference()
    {
        return $this->container['customer_account_reference'];
    }

    /**
     * Sets customer_account_reference
     *
     * @param string $customer_account_reference The unique identifier in the client system for the customer account.
     *
     * @return $this
     */
    public function setCustomerAccountReference($customer_account_reference)
    {
        $this->container['customer_account_reference'] = $customer_account_reference;

        return $this;
    }

    /**
     * Gets account_number
     *
     * @return string
     */
    public function getAccountNumber()
    {
        return $this->container['account_number'];
    }

    /**
     * Sets account_number
     *
     * @param string $account_number The number or reference that a customer uses to identify the customer's account.
     *
     * @return $this
     */
    public function setAccountNumber($account_number)
    {
        $this->container['account_number'] = $account_number;

        return $this;
    }

    /**
     * Gets current_balance
     *
     * @return string
     */
    public function getCurrentBalance()
    {
        return $this->container['current_balance'];
    }

    /**
     * Sets current_balance
     *
     * @param string $current_balance The current balance on the customer's account with the biller.
     *
     * @return $this
     */
    public function setCurrentBalance($current_balance)
    {
        $this->container['current_balance'] = $current_balance;

        return $this;
    }

    /**
     * Gets current_statement_balance
     *
     * @return string
     */
    public function getCurrentStatementBalance()
    {
        return $this->container['current_statement_balance'];
    }

    /**
     * Sets current_statement_balance
     *
     * @param string $current_statement_balance The balance on the customer’s account with the biller as reported on the last statement.
     *
     * @return $this
     */
    public function setCurrentStatementBalance($current_statement_balance)
    {
        $this->container['current_statement_balance'] = $current_statement_balance;

        return $this;
    }

    /**
     * Gets minimum_payment_due
     *
     * @return string
     */
    public function getMinimumPaymentDue()
    {
        return $this->container['minimum_payment_due'];
    }

    /**
     * Sets minimum_payment_due
     *
     * @param string $minimum_payment_due The minimum payment amount, as specified by the biller, that needs to be made against the customer’s account.
     *
     * @return $this
     */
    public function setMinimumPaymentDue($minimum_payment_due)
    {
        $this->container['minimum_payment_due'] = $minimum_payment_due;

        return $this;
    }

    /**
     * Gets past_amount_due
     *
     * @return string
     */
    public function getPastAmountDue()
    {
        return $this->container['past_amount_due'];
    }

    /**
     * Sets past_amount_due
     *
     * @param string $past_amount_due The amount that is due from the past bills/statements on the customer’s account with the biller.
     *
     * @return $this
     */
    public function setPastAmountDue($past_amount_due)
    {
        $this->container['past_amount_due'] = $past_amount_due;

        return $this;
    }

    /**
     * Gets payment_due_date
     *
     * @return string
     */
    public function getPaymentDueDate()
    {
        return $this->container['payment_due_date'];
    }

    /**
     * Sets payment_due_date
     *
     * @param string $payment_due_date The date by which the customer needs to clear the dues against the customer's account with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentDueDate($payment_due_date)
    {
        $this->container['payment_due_date'] = $payment_due_date;

        return $this;
    }

    /**
     * Gets statement_date
     *
     * @return string
     */
    public function getStatementDate()
    {
        return $this->container['statement_date'];
    }

    /**
     * Sets statement_date
     *
     * @param string $statement_date The date on which the biller generates the statement for the customer's account. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setStatementDate($statement_date)
    {
        $this->container['statement_date'] = $statement_date;

        return $this;
    }

    /**
     * Gets custom_fields
     *
     * @return map[string,string]
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     *
     * @param map[string,string] $custom_fields The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.
     *
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


