<?php



namespace Orbipay\PaymentsApi\Client\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;

/**
 * Warning:
 *
 * <p><font color="red"> This class subject to change without prior notice, Please dont use this class directly. </font></p>


 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Model
 */
class RecordedPaymentResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'RecordedPaymentResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'string',
        'url' => 'string',
        'fee' => '\Orbipay\PaymentsApi\Client\Model\FeeResponse',
        'status' => 'string',
        'payment_method' => 'string',
        'token' => 'string',
        'confirmation_number' => 'string',
        'custom_fields' => 'map[string,string]',
        'currency_code3d' => 'string',
        'amount' => 'string',
        'payment_date' => 'string',
        'payment_schedule_type' => 'string',
        'payment_amount_type' => 'string',
        'payment_reference' => 'string',
        'payment_entry_date' => 'string',
        'payment_return_date' => 'string',
        'comments' => 'string',
        'return_code' => 'string',
        'customer' => '\Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerResponse',
        'funding_account' => '\Orbipay\PaymentsApi\Client\Model\RecordedPaymentFundingAccount',
        'customer_account' => '\Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse',
        'audit_info' => '\Orbipay\PaymentsApi\Client\Model\AuditInfoVo'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'id' => null,
        'url' => null,
        'fee' => null,
        'status' => null,
        'payment_method' => null,
        'token' => null,
        'confirmation_number' => null,
        'custom_fields' => null,
        'currency_code3d' => null,
        'amount' => null,
        'payment_date' => null,
        'payment_schedule_type' => null,
        'payment_amount_type' => null,
        'payment_reference' => null,
        'payment_entry_date' => null,
        'payment_return_date' => null,
        'comments' => null,
        'return_code' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'audit_info' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'url' => 'url',
        'fee' => 'fee',
        'status' => 'status',
        'payment_method' => 'payment_method',
        'token' => 'token',
        'confirmation_number' => 'confirmation_number',
        'custom_fields' => 'custom_fields',
        'currency_code3d' => 'currency_code3d',
        'amount' => 'amount',
        'payment_date' => 'payment_date',
        'payment_schedule_type' => 'payment_schedule_type',
        'payment_amount_type' => 'payment_amount_type',
        'payment_reference' => 'payment_reference',
        'payment_entry_date' => 'payment_entry_date',
        'payment_return_date' => 'payment_return_date',
        'comments' => 'comments',
        'return_code' => 'return_code',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'audit_info' => 'audit_info'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'url' => 'setUrl',
        'fee' => 'setFee',
        'status' => 'setStatus',
        'payment_method' => 'setPaymentMethod',
        'token' => 'setToken',
        'confirmation_number' => 'setConfirmationNumber',
        'custom_fields' => 'setCustomFields',
        'currency_code3d' => 'setCurrencyCode3d',
        'amount' => 'setAmount',
        'payment_date' => 'setPaymentDate',
        'payment_schedule_type' => 'setPaymentScheduleType',
        'payment_amount_type' => 'setPaymentAmountType',
        'payment_reference' => 'setPaymentReference',
        'payment_entry_date' => 'setPaymentEntryDate',
        'payment_return_date' => 'setPaymentReturnDate',
        'comments' => 'setComments',
        'return_code' => 'setReturnCode',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'audit_info' => 'setAuditInfo'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'url' => 'getUrl',
        'fee' => 'getFee',
        'status' => 'getStatus',
        'payment_method' => 'getPaymentMethod',
        'token' => 'getToken',
        'confirmation_number' => 'getConfirmationNumber',
        'custom_fields' => 'getCustomFields',
        'currency_code3d' => 'getCurrencyCode3d',
        'amount' => 'getAmount',
        'payment_date' => 'getPaymentDate',
        'payment_schedule_type' => 'getPaymentScheduleType',
        'payment_amount_type' => 'getPaymentAmountType',
        'payment_reference' => 'getPaymentReference',
        'payment_entry_date' => 'getPaymentEntryDate',
        'payment_return_date' => 'getPaymentReturnDate',
        'comments' => 'getComments',
        'return_code' => 'getReturnCode',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'audit_info' => 'getAuditInfo'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const STATUS_PROCESSED = 'processed';
    const STATUS_CANCELLED = 'cancelled';
    const PAYMENT_METHOD_CASH = 'cash';
    const PAYMENT_METHOD_SWIPED_CARD = 'swiped_card';
    const PAYMENT_METHOD_SCANNED_CHECK = 'scanned_check';
    const PAYMENT_SCHEDULE_TYPE_ONE_TIME_PAYMENT = 'one_time_payment';
    const PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE = 'current_balance';
    const PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE = 'minimum_payment_due';
    const PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE = 'past_payment_due';
    const PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE = 'statement_balance';
    const PAYMENT_AMOUNT_TYPE_OTHER = 'other';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_PROCESSED,
            self::STATUS_CANCELLED,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentMethodAllowableValues()
    {
        return [
            self::PAYMENT_METHOD_CASH,
            self::PAYMENT_METHOD_SWIPED_CARD,
            self::PAYMENT_METHOD_SCANNED_CHECK,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentScheduleTypeAllowableValues()
    {
        return [
            self::PAYMENT_SCHEDULE_TYPE_ONE_TIME_PAYMENT,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentAmountTypeAllowableValues()
    {
        return [
            self::PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_OTHER,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['fee'] = isset($data['fee']) ? $data['fee'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['payment_method'] = isset($data['payment_method']) ? $data['payment_method'] : null;
        $this->container['token'] = isset($data['token']) ? $data['token'] : null;
        $this->container['confirmation_number'] = isset($data['confirmation_number']) ? $data['confirmation_number'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
        $this->container['currency_code3d'] = isset($data['currency_code3d']) ? $data['currency_code3d'] : null;
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['payment_date'] = isset($data['payment_date']) ? $data['payment_date'] : null;
        $this->container['payment_schedule_type'] = isset($data['payment_schedule_type']) ? $data['payment_schedule_type'] : null;
        $this->container['payment_amount_type'] = isset($data['payment_amount_type']) ? $data['payment_amount_type'] : null;
        $this->container['payment_reference'] = isset($data['payment_reference']) ? $data['payment_reference'] : null;
        $this->container['payment_entry_date'] = isset($data['payment_entry_date']) ? $data['payment_entry_date'] : null;
        $this->container['payment_return_date'] = isset($data['payment_return_date']) ? $data['payment_return_date'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['return_code'] = isset($data['return_code']) ? $data['return_code'] : null;
        $this->container['customer'] = isset($data['customer']) ? $data['customer'] : null;
        $this->container['funding_account'] = isset($data['funding_account']) ? $data['funding_account'] : null;
        $this->container['customer_account'] = isset($data['customer_account']) ? $data['customer_account'] : null;
        $this->container['audit_info'] = isset($data['audit_info']) ? $data['audit_info'] : null;
    }


    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id The unique identifier assigned by EBPP to the payment.
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url This URL fetches the details of payment.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets fee
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FeeResponse
     */
    public function getFee()
    {
        return $this->container['fee'];
    }

    /**
     * Sets fee
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FeeResponse $fee fee
     *
     * @return $this
     */
    public function setFee($fee)
    {
        $this->container['fee'] = $fee;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status The status of the payment.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets payment_method
     *
     * @return string
     */
    public function getPaymentMethod()
    {
        return $this->container['payment_method'];
    }

    /**
     * Sets payment_method
     *
     * @param string $payment_method The non fulfillment method for the payment.
     *
     * @return $this
     */
    public function setPaymentMethod($payment_method)
    {
        $this->container['payment_method'] = $payment_method;

        return $this;
    }

    /**
     * Gets token
     *
     * @return string
     */
    public function getToken()
    {
        return $this->container['token'];
    }

    /**
     * Sets token
     *
     * @param string $token The token is used to uniquely identify the payment, such as the POS token.
     *
     * @return $this
     */
    public function setToken($token)
    {
        $this->container['token'] = $token;

        return $this;
    }

    /**
     * Gets confirmation_number
     *
     * @return string
     */
    public function getConfirmationNumber()
    {
        return $this->container['confirmation_number'];
    }

    /**
     * Sets confirmation_number
     *
     * @param string $confirmation_number The confirmation number or reference provided to the customer for the payment.
     *
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        $this->container['confirmation_number'] = $confirmation_number;

        return $this;
    }

    /**
     * Gets custom_fields
     *
     * @return map[string,string]
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     *
     * @param map[string,string] $custom_fields The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.
     *
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Gets currency_code3d
     *
     * @return string
     */
    public function getCurrencyCode3d()
    {
        return $this->container['currency_code3d'];
    }

    /**
     * Sets currency_code3d
     *
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.
     *
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->container['currency_code3d'] = $currency_code3d;

        return $this;
    }

    /**
     * Gets amount
     *
     * @return string
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     *
     * @param string $amount The amount being paid. In case the payment_amount_type is 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     *
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets payment_date
     *
     * @return string
     */
    public function getPaymentDate()
    {
        return $this->container['payment_date'];
    }

    /**
     * Sets payment_date
     *
     * @param string $payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentDate($payment_date)
    {
        $this->container['payment_date'] = $payment_date;

        return $this;
    }

    /**
     * Gets payment_schedule_type
     *
     * @return string
     */
    public function getPaymentScheduleType()
    {
        return $this->container['payment_schedule_type'];
    }

    /**
     * Sets payment_schedule_type
     *
     * @param string $payment_schedule_type The schedule type for the payment. This defaults to one_time_payment.
     *
     * @return $this
     */
    public function setPaymentScheduleType($payment_schedule_type)
    {
        $this->container['payment_schedule_type'] = $payment_schedule_type;

        return $this;
    }

    /**
     * Gets payment_amount_type
     *
     * @return string
     */
    public function getPaymentAmountType()
    {
        return $this->container['payment_amount_type'];
    }

    /**
     * Sets payment_amount_type
     *
     * @param string $payment_amount_type The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.
     *
     * @return $this
     */
    public function setPaymentAmountType($payment_amount_type)
    {
        $this->container['payment_amount_type'] = $payment_amount_type;

        return $this;
    }

    /**
     * Gets payment_reference
     *
     * @return string
     */
    public function getPaymentReference()
    {
        return $this->container['payment_reference'];
    }

    /**
     * Sets payment_reference
     *
     * @param string $payment_reference The unique identifier in the client system for the payment.
     *
     * @return $this
     */
    public function setPaymentReference($payment_reference)
    {
        $this->container['payment_reference'] = $payment_reference;

        return $this;
    }

    /**
     * Gets payment_entry_date
     *
     * @return string
     */
    public function getPaymentEntryDate()
    {
        return $this->container['payment_entry_date'];
    }

    /**
     * Sets payment_entry_date
     *
     * @param string $payment_entry_date The date on which the payment is captured in EBPP. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentEntryDate($payment_entry_date)
    {
        $this->container['payment_entry_date'] = $payment_entry_date;

        return $this;
    }

    /**
     * Gets payment_return_date
     *
     * @return string
     */
    public function getPaymentReturnDate()
    {
        return $this->container['payment_return_date'];
    }

    /**
     * Sets payment_return_date
     *
     * @param string $payment_return_date The date on which the ACH returns is received by EBPP.
     *
     * @return $this
     */
    public function setPaymentReturnDate($payment_return_date)
    {
        $this->container['payment_return_date'] = $payment_return_date;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object.
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets return_code
     *
     * @return string
     */
    public function getReturnCode()
    {
        return $this->container['return_code'];
    }

    /**
     * Sets return_code
     *
     * @param string $return_code The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments.
     *
     * @return $this
     */
    public function setReturnCode($return_code)
    {
        $this->container['return_code'] = $return_code;

        return $this;
    }

    /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerResponse
     */
    public function getCustomer()
    {
        return $this->container['customer'];
    }

    /**
     * Sets customer
     *
     * @param \Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerResponse $customer customer
     *
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->container['customer'] = $customer;

        return $this;
    }

    /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\RecordedPaymentFundingAccount
     */
    public function getFundingAccount()
    {
        return $this->container['funding_account'];
    }

    /**
     * Sets funding_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\RecordedPaymentFundingAccount $funding_account funding_account
     *
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->container['funding_account'] = $funding_account;

        return $this;
    }

    /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse
     */
    public function getCustomerAccount()
    {
        return $this->container['customer_account'];
    }

    /**
     * Sets customer_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse $customer_account customer_account
     *
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->container['customer_account'] = $customer_account;

        return $this;
    }

    /**
     * Gets audit_info
     *
     * @return \Orbipay\PaymentsApi\Client\Model\AuditInfoVo
     */
    public function getAuditInfo()
    {
        return $this->container['audit_info'];
    }

    /**
     * Sets audit_info
     *
     * @param \Orbipay\PaymentsApi\Client\Model\AuditInfoVo $audit_info audit_info
     *
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->container['audit_info'] = $audit_info;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


