<?php



namespace Orbipay\PaymentsApi\Client\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;

/**
 * Warning:
 *
 * <p><font color="red"> This class subject to change without prior notice, Please dont use this class directly. </font></p>


 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Model
 */
class SimplePaymentRequest implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'SimplePaymentRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'amount' => 'string',
        'card_cvv_number' => 'string',
        'payment_date' => 'string',
        'payment_request_date' => 'string',
        'payment_amount_type' => 'string',
        'fee' => '\Orbipay\PaymentsApi\Client\Model\FeeRequest',
        'customer' => '\Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerRequest',
        'funding_account' => '\Orbipay\PaymentsApi\Client\Model\SimplePaymentFundingAccountRequest',
        'customer_account' => '\Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerAccountRequest',
        'payment_reference' => 'string',
        'payment_notification_email' => 'string',
        'cryptogram' => 'string',
        'eci' => 'string',
        'comments' => 'string',
        'custom_fields' => 'map[string,string]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'amount' => null,
        'card_cvv_number' => null,
        'payment_date' => null,
        'payment_request_date' => null,
        'payment_amount_type' => null,
        'fee' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'payment_reference' => null,
        'payment_notification_email' => 'email',
        'cryptogram' => null,
        'eci' => null,
        'comments' => null,
        'custom_fields' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'amount' => 'amount',
        'card_cvv_number' => 'card_cvv_number',
        'payment_date' => 'payment_date',
        'payment_request_date' => 'payment_request_date',
        'payment_amount_type' => 'payment_amount_type',
        'fee' => 'fee',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'payment_reference' => 'payment_reference',
        'payment_notification_email' => 'payment_notification_email',
        'cryptogram' => 'cryptogram',
        'eci' => 'eci',
        'comments' => 'comments',
        'custom_fields' => 'custom_fields'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'amount' => 'setAmount',
        'card_cvv_number' => 'setCardCvvNumber',
        'payment_date' => 'setPaymentDate',
        'payment_request_date' => 'setPaymentRequestDate',
        'payment_amount_type' => 'setPaymentAmountType',
        'fee' => 'setFee',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'payment_reference' => 'setPaymentReference',
        'payment_notification_email' => 'setPaymentNotificationEmail',
        'cryptogram' => 'setCryptogram',
        'eci' => 'setEci',
        'comments' => 'setComments',
        'custom_fields' => 'setCustomFields'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'amount' => 'getAmount',
        'card_cvv_number' => 'getCardCvvNumber',
        'payment_date' => 'getPaymentDate',
        'payment_request_date' => 'getPaymentRequestDate',
        'payment_amount_type' => 'getPaymentAmountType',
        'fee' => 'getFee',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'payment_reference' => 'getPaymentReference',
        'payment_notification_email' => 'getPaymentNotificationEmail',
        'cryptogram' => 'getCryptogram',
        'eci' => 'getEci',
        'comments' => 'getComments',
        'custom_fields' => 'getCustomFields'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE = 'current_balance';
    const PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE = 'minimum_payment_due';
    const PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE = 'past_payment_due';
    const PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE = 'statement_balance';
    const PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT = 'discounted_amount';
    const PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT = 'penalty_amount';
    const PAYMENT_AMOUNT_TYPE_OTHER = 'other';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentAmountTypeAllowableValues()
    {
        return [
            self::PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_OTHER,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['card_cvv_number'] = isset($data['card_cvv_number']) ? $data['card_cvv_number'] : null;
        $this->container['payment_date'] = isset($data['payment_date']) ? $data['payment_date'] : null;
        $this->container['payment_request_date'] = isset($data['payment_request_date']) ? $data['payment_request_date'] : null;
        $this->container['payment_amount_type'] = isset($data['payment_amount_type']) ? $data['payment_amount_type'] : null;
        $this->container['fee'] = isset($data['fee']) ? $data['fee'] : null;
        $this->container['customer'] = isset($data['customer']) ? $data['customer'] : null;
        $this->container['funding_account'] = isset($data['funding_account']) ? $data['funding_account'] : null;
        $this->container['customer_account'] = isset($data['customer_account']) ? $data['customer_account'] : null;
        $this->container['payment_reference'] = isset($data['payment_reference']) ? $data['payment_reference'] : null;
        $this->container['payment_notification_email'] = isset($data['payment_notification_email']) ? $data['payment_notification_email'] : null;
        $this->container['cryptogram'] = isset($data['cryptogram']) ? $data['cryptogram'] : null;
        $this->container['eci'] = isset($data['eci']) ? $data['eci'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
    }


    /**
     * Gets amount
     *
     * @return string
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     *
     * @param string $amount The amount being paid.
     *
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets card_cvv_number
     *
     * @return string
     */
    public function getCardCvvNumber()
    {
        return $this->container['card_cvv_number'];
    }

    /**
     * Sets card_cvv_number
     *
     * @param string $card_cvv_number card_cvv_number
     *
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->container['card_cvv_number'] = $card_cvv_number;

        return $this;
    }

    /**
     * Gets payment_date
     *
     * @return string
     */
    public function getPaymentDate()
    {
        return $this->container['payment_date'];
    }

    /**
     * Sets payment_date
     *
     * @param string $payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentDate($payment_date)
    {
        $this->container['payment_date'] = $payment_date;

        return $this;
    }

    /**
     * Gets payment_request_date
     *
     * @return string
     */
    public function getPaymentRequestDate()
    {
        return $this->container['payment_request_date'];
    }

    /**
     * Sets payment_request_date
     *
     * @param string $payment_request_date The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentRequestDate($payment_request_date)
    {
        $this->container['payment_request_date'] = $payment_request_date;

        return $this;
    }

    /**
     * Gets payment_amount_type
     *
     * @return string
     */
    public function getPaymentAmountType()
    {
        return $this->container['payment_amount_type'];
    }

    /**
     * Sets payment_amount_type
     *
     * @param string $payment_amount_type The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment.
     *
     * @return $this
     */
    public function setPaymentAmountType($payment_amount_type)
    {
        $this->container['payment_amount_type'] = $payment_amount_type;

        return $this;
    }

    /**
     * Gets fee
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FeeRequest
     */
    public function getFee()
    {
        return $this->container['fee'];
    }

    /**
     * Sets fee
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FeeRequest $fee fee
     *
     * @return $this
     */
    public function setFee($fee)
    {
        $this->container['fee'] = $fee;

        return $this;
    }

    /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerRequest
     */
    public function getCustomer()
    {
        return $this->container['customer'];
    }

    /**
     * Sets customer
     *
     * @param \Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerRequest $customer customer
     *
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->container['customer'] = $customer;

        return $this;
    }

    /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\SimplePaymentFundingAccountRequest
     */
    public function getFundingAccount()
    {
        return $this->container['funding_account'];
    }

    /**
     * Sets funding_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\SimplePaymentFundingAccountRequest $funding_account funding_account
     *
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->container['funding_account'] = $funding_account;

        return $this;
    }

    /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerAccountRequest
     */
    public function getCustomerAccount()
    {
        return $this->container['customer_account'];
    }

    /**
     * Sets customer_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerAccountRequest $customer_account customer_account
     *
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->container['customer_account'] = $customer_account;

        return $this;
    }

    /**
     * Gets payment_reference
     *
     * @return string
     */
    public function getPaymentReference()
    {
        return $this->container['payment_reference'];
    }

    /**
     * Sets payment_reference
     *
     * @param string $payment_reference The unique identifier in the client system for the payment.
     *
     * @return $this
     */
    public function setPaymentReference($payment_reference)
    {
        $this->container['payment_reference'] = $payment_reference;

        return $this;
    }

    /**
     * Gets payment_notification_email
     *
     * @return string
     */
    public function getPaymentNotificationEmail()
    {
        return $this->container['payment_notification_email'];
    }

    /**
     * Sets payment_notification_email
     *
     * @param string $payment_notification_email The email address to which notifications for the payment will be sent.
     *
     * @return $this
     */
    public function setPaymentNotificationEmail($payment_notification_email)
    {
        $this->container['payment_notification_email'] = $payment_notification_email;

        return $this;
    }

    /**
     * Gets cryptogram
     *
     * @return string
     */
    public function getCryptogram()
    {
        return $this->container['cryptogram'];
    }

    /**
     * Sets cryptogram
     *
     * @param string $cryptogram Online Payment Cryptogram, as defined by 3-D secure.
     *
     * @return $this
     */
    public function setCryptogram($cryptogram)
    {
        $this->container['cryptogram'] = $cryptogram;

        return $this;
    }

    /**
     * Gets eci
     *
     * @return string
     */
    public function getEci()
    {
        return $this->container['eci'];
    }

    /**
     * Sets eci
     *
     * @param string $eci ECI Indicator, as defined by 3-D secure. The card network may add an ECI indicator to the card data.
     *
     * @return $this
     */
    public function setEci($eci)
    {
        $this->container['eci'] = $eci;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object.
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets custom_fields
     *
     * @return map[string,string]
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     *
     * @param map[string,string] $custom_fields The additional information or meta-information that EBPP can accept, maintain and transmit back to the client.
     *
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


