<?php

/**
 * PaymentAuthorization
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */



/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * PaymentAuthorization Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */
class PaymentAuthorization  extends Base 
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'payment_auth_reference' => 'string', 
        'id' => 'string', 
        'url' => 'string', 
        'auth_amount' => 'string', 
        'status' => 'string', 
        'payment_method' => 'string', 
        'currency_code3d' => 'string', 
        'card_cvv_number' => 'string', 
        'entry_time' => 'string', 
        'captured_time' => 'string', 
        'comments' => 'string', 
        'custom_fields' => 'map[string,string]', 
        'customer' => '\Orbipay\PaymentsApi\Client\Wrappers\Customer', 
        'funding_account' => '\Orbipay\PaymentsApi\Client\Wrappers\FundingAccount', 
        'customer_account' => '\Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount', 
        'payment_network_response' => '\Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse', 
        'audit_info' => '\Orbipay\PaymentsApi\Client\Wrappers\AuditInfo', 
        'id_customer' => 'string', 
        'id_authorization' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'payment_auth_reference' => null,
        'id' => null,
        'url' => null,
        'auth_amount' => null,
        'status' => null,
        'payment_method' => null,
        'currency_code3d' => null,
        'card_cvv_number' => null,
        'entry_time' => null,
        'captured_time' => null,
        'comments' => null,
        'custom_fields' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'payment_network_response' => null,
        'audit_info' => null,
        'id_customer' => null,
        'id_authorization' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'payment_auth_reference' => 'payment_auth_reference',
        'id' => 'id',
        'url' => 'url',
        'auth_amount' => 'auth_amount',
        'status' => 'status',
        'payment_method' => 'payment_method',
        'currency_code3d' => 'currency_code3d',
        'card_cvv_number' => 'card_cvv_number',
        'entry_time' => 'entry_time',
        'captured_time' => 'captured_time',
        'comments' => 'comments',
        'custom_fields' => 'custom_fields',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'payment_network_response' => 'payment_network_response',
        'audit_info' => 'audit_info',
        'id_customer' => 'ID_CUSTOMER',
        'id_authorization' => 'ID_AUTHORIZATION'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'payment_auth_reference' => 'setPaymentAuthReference',
        'id' => 'setId',
        'url' => 'setUrl',
        'auth_amount' => 'setAuthAmount',
        'status' => 'setStatus',
        'payment_method' => 'setPaymentMethod',
        'currency_code3d' => 'setCurrencyCode3d',
        'card_cvv_number' => 'setCardCvvNumber',
        'entry_time' => 'setEntryTime',
        'captured_time' => 'setCapturedTime',
        'comments' => 'setComments',
        'custom_fields' => 'setCustomFields',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'payment_network_response' => 'setPaymentNetworkResponse',
        'audit_info' => 'setAuditInfo',
        'id_customer' => 'setIdCustomer',
        'id_authorization' => 'setIdAuthorization'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'payment_auth_reference' => 'getPaymentAuthReference',
        'id' => 'getId',
        'url' => 'getUrl',
        'auth_amount' => 'getAuthAmount',
        'status' => 'getStatus',
        'payment_method' => 'getPaymentMethod',
        'currency_code3d' => 'getCurrencyCode3d',
        'card_cvv_number' => 'getCardCvvNumber',
        'entry_time' => 'getEntryTime',
        'captured_time' => 'getCapturedTime',
        'comments' => 'getComments',
        'custom_fields' => 'getCustomFields',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'payment_network_response' => 'getPaymentNetworkResponse',
        'audit_info' => 'getAuditInfo',
        'id_customer' => 'getIdCustomer',
        'id_authorization' => 'getIdAuthorization'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets payment_auth_reference
     * @param string $payment_auth_reference The unique identifier in the client system for the payment.
     * @return $this
     */
    public function setPaymentAuthReference($payment_auth_reference)
    {
        $this->payment_auth_reference = $payment_auth_reference;

        return $this;
    }

    /**
     * @internal
     * Sets id
     * @param string $id The unique identifier assigned by EBPP to the payment authorization.
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the details of payment authorization.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets auth_amount
     * @param string $auth_amount The amount being authorized.
     * @return $this
     */
    public function setAuthAmount($auth_amount)
    {
        $this->auth_amount = $auth_amount;

        return $this;
    }

    /**
     * @internal
     * Sets status
     * @param string $status The status of the payment.
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * @internal
     * Sets payment_method
     * @param string $payment_method The fulfillment method for the payment authorization.
     * @return $this
     */
    public function setPaymentMethod($payment_method)
    {
        $this->payment_method = $payment_method;

        return $this;
    }

    /**
     * @internal
     * Sets currency_code3d
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->currency_code3d = $currency_code3d;

        return $this;
    }

    /**
     * @internal
     * Sets card_cvv_number
     * @param string $card_cvv_number This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment with a card funding account.
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->card_cvv_number = $card_cvv_number;

        return $this;
    }

    /**
     * @internal
     * Sets entry_time
     * @param string $entry_time The date on which the payment authorization created in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000.
     * @return $this
     */
    public function setEntryTime($entry_time)
    {
        $this->entry_time = $entry_time;

        return $this;
    }

    /**
     * @internal
     * Sets captured_time
     * @param string $captured_time The date on which the payment authorization is captured in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000..
     * @return $this
     */
    public function setCapturedTime($captured_time)
    {
        $this->captured_time = $captured_time;

        return $this;
    }

    /**
     * @internal
     * Sets comments
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     * @return $this
     */
    public function setComments($comments)
    {
        $this->comments = $comments;

        return $this;
    }

    /**
     * @internal
     * Sets custom_fields
     * @param map[string,string] $custom_fields The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->custom_fields = $custom_fields;

        return $this;
    }

    /**
     * @internal
     * Sets customer
     * @param \Orbipay\PaymentsApi\Client\Wrappers\Customer $customer customer
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->customer = $customer;

        return $this;
    }

    /**
     * @internal
     * Sets funding_account
     * @param \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount $funding_account funding_account
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->funding_account = $funding_account;

        return $this;
    }

    /**
     * @internal
     * Sets customer_account
     * @param \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount $customer_account customer_account
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->customer_account = $customer_account;

        return $this;
    }

    /**
     * @internal
     * Sets payment_network_response
     * @param \Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse $payment_network_response payment_network_response
     * @return $this
     */
    public function setPaymentNetworkResponse($payment_network_response)
    {
        $this->payment_network_response = $payment_network_response;

        return $this;
    }

    /**
     * @internal
     * Sets audit_info
     * @param \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo $audit_info audit_info
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->audit_info = $audit_info;

        return $this;
    }

    /**
     * @internal
     * Sets id_customer
     * @param string $id_customer The unique identifier assigned by EBPP to the customer.
     * @return $this
     */
    public function setIdCustomer($id_customer)
    {
        $this->id_customer = $id_customer;

        return $this;
    }

    /**
     * @internal
     * Sets id_authorization
     * @param string $id_authorization The unique identifier assigned by EBPP to the payment authorization.
     * @return $this
     */
    public function setIdAuthorization($id_authorization)
    {
        $this->id_authorization = $id_authorization;

        return $this;
    }

    /**
     * @var string 
     * $payment_auth_reference The unique identifier in the client system for the payment.
     */
    private $payment_auth_reference;
  
     /**
     * Gets payment_auth_reference
     *
     * @return string $payment_auth_reference The unique identifier in the client system for the payment.
     */
    public function getPaymentAuthReference()
    {
        return $this->payment_auth_reference;
    }
    /**
     * @var string 
     * $id The unique identifier assigned by EBPP to the payment authorization.
     */
    private $id;
  
     /**
     * Gets id
     *
     * @return string $id The unique identifier assigned by EBPP to the payment authorization.
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * @var string 
     * $url This URL fetches the details of payment authorization.
     */
    private $url;
  
     /**
     * Gets url
     *
     * @return string $url This URL fetches the details of payment authorization.
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * @var string 
     * $auth_amount The amount being authorized.
     */
    private $auth_amount;
  
     /**
     * Gets auth_amount
     *
     * @return string $auth_amount The amount being authorized.
     */
    public function getAuthAmount()
    {
        return $this->auth_amount;
    }
        
   /**
     * @var string $status The status of the payment.
     */
    private $status;
    
    /**
     * Gets status
     *
     * @return string $status The status of the payment.
     */

    public function getStatus()
    {
        return $this->status;
    }
    
        
   /**
     * @var string $payment_method The fulfillment method for the payment authorization.
     */
    private $payment_method;
    
    /**
     * Gets payment_method
     *
     * @return string $payment_method The fulfillment method for the payment authorization.
     */

    public function getPaymentMethod()
    {
        return $this->payment_method;
    }
    
    /**
     * @var string 
     * $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.
     */
    private $currency_code3d;
  
     /**
     * Gets currency_code3d
     *
     * @return string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.
     */
    public function getCurrencyCode3d()
    {
        return $this->currency_code3d;
    }
    /**
     * @var string 
     * $card_cvv_number This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment with a card funding account.
     */
    private $card_cvv_number;
  
     /**
     * Gets card_cvv_number
     *
     * @return string $card_cvv_number This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment with a card funding account.
     */
    public function getCardCvvNumber()
    {
        return $this->card_cvv_number;
    }
    /**
     * @var string 
     * $entry_time The date on which the payment authorization created in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000.
     */
    private $entry_time;
  
     /**
     * Gets entry_time
     *
     * @return string $entry_time The date on which the payment authorization created in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000.
     */
    public function getEntryTime()
    {
        return $this->entry_time;
    }
    /**
     * @var string 
     * $captured_time The date on which the payment authorization is captured in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000..
     */
    private $captured_time;
  
     /**
     * Gets captured_time
     *
     * @return string $captured_time The date on which the payment authorization is captured in UTC timestamp, with ISO8601 format. For e.g., 2019-08-13T09:21:34.359+0000..
     */
    public function getCapturedTime()
    {
        return $this->captured_time;
    }
    /**
     * @var string 
     * $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     */
    private $comments;
  
     /**
     * Gets comments
     *
     * @return string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     */
    public function getComments()
    {
        return $this->comments;
    }
    /**
     * @var map[string,string] 
     * $custom_fields The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.
     */
    private $custom_fields;
  
     /**
     * Gets custom_fields
     *
     * @return map[string,string] $custom_fields The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in EBPP, would be accepted in the requests.
     */
    public function getCustomFields()
    {
        return $this->custom_fields;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\Customer 
     * $customer customer
     */
    private $customer;
  
     /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\Customer $customer customer
     */
    public function getCustomer()
    {
        return $this->customer;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount 
     * $funding_account funding_account
     */
    private $funding_account;
  
     /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount $funding_account funding_account
     */
    public function getFundingAccount()
    {
        return $this->funding_account;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount 
     * $customer_account customer_account
     */
    private $customer_account;
  
     /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount $customer_account customer_account
     */
    public function getCustomerAccount()
    {
        return $this->customer_account;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse 
     * $payment_network_response payment_network_response
     */
    private $payment_network_response;
  
     /**
     * Gets payment_network_response
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse $payment_network_response payment_network_response
     */
    public function getPaymentNetworkResponse()
    {
        return $this->payment_network_response;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo 
     * $audit_info audit_info
     */
    private $audit_info;
  
     /**
     * Gets audit_info
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo $audit_info audit_info
     */
    public function getAuditInfo()
    {
        return $this->audit_info;
    }
    /**
     * @var string 
     * $id_customer The unique identifier assigned by EBPP to the customer.
     */
    private $id_customer;
  
     /**
     * Gets id_customer
     *
     * @return string $id_customer The unique identifier assigned by EBPP to the customer.
     */
    public function getIdCustomer()
    {
        return $this->id_customer;
    }
    /**
     * @var string 
     * $id_authorization The unique identifier assigned by EBPP to the payment authorization.
     */
    private $id_authorization;
  
     /**
     * Gets id_authorization
     *
     * @return string $id_authorization The unique identifier assigned by EBPP to the payment authorization.
     */
    public function getIdAuthorization()
    {
        return $this->id_authorization;
    }

    
     /**
     * PaymentAuthorization constructor.
     * @param string $id_authorization 
     */
    public function __construct($id_authorization = null)
    {
        $this->id_authorization = $id_authorization;
		$this->id = $id_authorization;
    }
       
    public function forClient($client_key = null)
    {
		parent::forClient($client_key);
        
        return $this; 
    }
    public function videChannel($channel = null)
    {
		parent::videChannel($channel);
        
        return $this; 
    }
    public function withDetails($auth_amount = null, $card_cvv_number = null)
    {
        			$this->auth_amount = $auth_amount;
        		
        

        			$this->card_cvv_number = $card_cvv_number;
        		
        

        
        return $this; 
    }
    public function forCustomer($id_customer = null)
    {
        			$this->id_customer = $id_customer;
        		
        
	    $jsonArray = null;
	  	if($this->customer != null) {
		  	$serializedObject=ObjectSerializer::sanitizeForSerialization($this->customer);
	        $encodedString = json_encode($serializedObject);
	        $jsonArray = json_decode($encodedString,true);
		  	$jsonArray["id"] = $id_customer;
	  	}
	  	else {
	  		$jsonArray["id"] = $id_customer;
	  	}
	  	 $encodedJsonArray = json_encode($jsonArray);
	  	$this->customer =  ObjectSerializer::deserialize(json_decode($encodedJsonArray),'\Orbipay\PaymentsApi\Client\Wrappers\Customer',null);

        
        return $this; 
    }
    public function fromAccount($funding_account = null)
    {
        			$this->funding_account = $funding_account;
        		
        

        
        return $this; 
    }
    public function toAccount($customer_account = null)
    {
        			$this->customer_account = $customer_account;
        		
        

        
        return $this; 
    }
    public function withReference($payment_auth_reference = null)
    {
        			$this->payment_auth_reference = $payment_auth_reference;
        		
        

        
        return $this; 
    }
    public function withCustomFields($custom_fields = null)
    {
				if(isset($custom_fields)){
					if(count($custom_fields) == 0){
						$this->custom_fields = null;
					}
					else{
        				$this->custom_fields = $custom_fields;
					}
        		}else{
        			$this->custom_fields = $custom_fields;
        		}
        		
        

        
        return $this; 
    }
    public function withMemo($comments = null)
    {
        			$this->comments = $comments;
        		
        

        
        return $this; 
    }
    
	/**
     * cancelledBy
     *
     * @param $requestor
     * @param $requestor_type
     * @return PaymentAuthorization
     */
    public function cancelledBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

	/**
     * createdBy
     *
     * @param $requestor
     * @param $requestor_type
     * @return PaymentAuthorization
     */
    public function createdBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    
	/**
     * cancel
     *
     * @param InvocationContext $invocationContext
     * @param string $liveMode
     * @param string $apiEndPoint
     * @return PaymentAuthorization
     * @throws OrbipayApiException
     */
    public function cancel(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\CancelPaymentAuthorizationHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
	/**
     * create
     *
     * @param InvocationContext $invocationContext
     * @param string $liveMode
     * @param string $apiEndPoint
     * @return PaymentAuthorization
     * @throws OrbipayApiException
     */
    public function create(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\CreatePaymentAuthorizationHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) , parent::jsonSerialize());
    }
}


