<?php

/**
 * PaymentSetup
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */



/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * PaymentSetup Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */
class PaymentSetup  extends Base 
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'string', 
        'url' => 'string', 
        'fee' => '\Orbipay\PaymentsApi\Client\Wrappers\Fee', 
        'status' => 'string', 
        'payment_method' => 'string', 
        'payment_setup_schedule_type' => 'string', 
        'confirmation_number' => 'string', 
        'custom_fields' => 'map[string,string]', 
        'currency_code3d' => 'string', 
        'amount' => 'string', 
        'card_cvv_number' => 'string', 
        'next_payment_date' => 'string', 
        'payment_setup_reference' => 'string', 
        'payment_schedule' => '\Orbipay\PaymentsApi\Client\Wrappers\PaymentSchedule', 
        'payment_setup_entry_date' => 'string', 
        'comments' => 'string', 
        'deleted' => 'string', 
        'customer' => '\Orbipay\PaymentsApi\Client\Wrappers\Customer', 
        'funding_account' => '\Orbipay\PaymentsApi\Client\Wrappers\FundingAccount', 
        'customer_account' => '\Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount', 
        'payment_network_response' => '\Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse', 
        'audit_info' => '\Orbipay\PaymentsApi\Client\Wrappers\AuditInfo', 
        'id_customer' => 'string', 
        'id_payment_setup' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'id' => null,
        'url' => null,
        'fee' => null,
        'status' => null,
        'payment_method' => null,
        'payment_setup_schedule_type' => null,
        'confirmation_number' => null,
        'custom_fields' => null,
        'currency_code3d' => null,
        'amount' => null,
        'card_cvv_number' => null,
        'next_payment_date' => null,
        'payment_setup_reference' => null,
        'payment_schedule' => null,
        'payment_setup_entry_date' => null,
        'comments' => null,
        'deleted' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'payment_network_response' => null,
        'audit_info' => null,
        'id_customer' => null,
        'id_payment_setup' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'url' => 'url',
        'fee' => 'fee',
        'status' => 'status',
        'payment_method' => 'payment_method',
        'payment_setup_schedule_type' => 'payment_setup_schedule_type',
        'confirmation_number' => 'confirmation_number',
        'custom_fields' => 'custom_fields',
        'currency_code3d' => 'currency_code3d',
        'amount' => 'amount',
        'card_cvv_number' => 'card_cvv_number',
        'next_payment_date' => 'next_payment_date',
        'payment_setup_reference' => 'payment_setup_reference',
        'payment_schedule' => 'payment_schedule',
        'payment_setup_entry_date' => 'payment_setup_entry_date',
        'comments' => 'comments',
        'deleted' => 'deleted',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'payment_network_response' => 'payment_network_response',
        'audit_info' => 'audit_info',
        'id_customer' => 'ID_CUSTOMER',
        'id_payment_setup' => 'ID_PAYMENT_SETUP'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'url' => 'setUrl',
        'fee' => 'setFee',
        'status' => 'setStatus',
        'payment_method' => 'setPaymentMethod',
        'payment_setup_schedule_type' => 'setPaymentSetupScheduleType',
        'confirmation_number' => 'setConfirmationNumber',
        'custom_fields' => 'setCustomFields',
        'currency_code3d' => 'setCurrencyCode3d',
        'amount' => 'setAmount',
        'card_cvv_number' => 'setCardCvvNumber',
        'next_payment_date' => 'setNextPaymentDate',
        'payment_setup_reference' => 'setPaymentSetupReference',
        'payment_schedule' => 'setPaymentSchedule',
        'payment_setup_entry_date' => 'setPaymentSetupEntryDate',
        'comments' => 'setComments',
        'deleted' => 'setDeleted',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'payment_network_response' => 'setPaymentNetworkResponse',
        'audit_info' => 'setAuditInfo',
        'id_customer' => 'setIdCustomer',
        'id_payment_setup' => 'setIdPaymentSetup'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'url' => 'getUrl',
        'fee' => 'getFee',
        'status' => 'getStatus',
        'payment_method' => 'getPaymentMethod',
        'payment_setup_schedule_type' => 'getPaymentSetupScheduleType',
        'confirmation_number' => 'getConfirmationNumber',
        'custom_fields' => 'getCustomFields',
        'currency_code3d' => 'getCurrencyCode3d',
        'amount' => 'getAmount',
        'card_cvv_number' => 'getCardCvvNumber',
        'next_payment_date' => 'getNextPaymentDate',
        'payment_setup_reference' => 'getPaymentSetupReference',
        'payment_schedule' => 'getPaymentSchedule',
        'payment_setup_entry_date' => 'getPaymentSetupEntryDate',
        'comments' => 'getComments',
        'deleted' => 'getDeleted',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'payment_network_response' => 'getPaymentNetworkResponse',
        'audit_info' => 'getAuditInfo',
        'id_customer' => 'getIdCustomer',
        'id_payment_setup' => 'getIdPaymentSetup'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets id
     * @param string $id The unique identifier assigned by Orbipay to the payment setup.
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the details of payment setup.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets fee
     * @param \Orbipay\PaymentsApi\Client\Wrappers\Fee $fee fee
     * @return $this
     */
    public function setFee($fee)
    {
        $this->fee = $fee;

        return $this;
    }

    /**
     * @internal
     * Sets status
     * @param string $status The status of the payment.
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * @internal
     * Sets payment_method
     * @param string $payment_method The fulfillment method for the payment.
     * @return $this
     */
    public function setPaymentMethod($payment_method)
    {
        $this->payment_method = $payment_method;

        return $this;
    }

    /**
     * @internal
     * Sets payment_setup_schedule_type
     * @param string $payment_setup_schedule_type The schedule type for the payment setup.
     * @return $this
     */
    public function setPaymentSetupScheduleType($payment_setup_schedule_type)
    {
        $this->payment_setup_schedule_type = $payment_setup_schedule_type;

        return $this;
    }

    /**
     * @internal
     * Sets confirmation_number
     * @param string $confirmation_number The confirmation number or reference provided to the customer for the payment setup.
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        $this->confirmation_number = $confirmation_number;

        return $this;
    }

    /**
     * @internal
     * Sets custom_fields
     * @param map[string,string] $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in Orbipay, would be accepted in the requests.
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->custom_fields = $custom_fields;

        return $this;
    }

    /**
     * @internal
     * Sets currency_code3d
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by Orbipay. This defaults to USD.
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->currency_code3d = $currency_code3d;

        return $this;
    }

    /**
     * @internal
     * Sets amount
     * @param string $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->amount = $amount;

        return $this;
    }

    /**
     * @internal
     * Sets card_cvv_number
     * @param string $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment setup with a card funding account.
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->card_cvv_number = $card_cvv_number;

        return $this;
    }

    /**
     * @internal
     * Sets next_payment_date
     * @param string $next_payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     * @return $this
     */
    public function setNextPaymentDate($next_payment_date)
    {
        $this->next_payment_date = $next_payment_date;

        return $this;
    }

    /**
     * @internal
     * Sets payment_setup_reference
     * @param string $payment_setup_reference The unique identifier in the client system for the payment setup.
     * @return $this
     */
    public function setPaymentSetupReference($payment_setup_reference)
    {
        $this->payment_setup_reference = $payment_setup_reference;

        return $this;
    }

    /**
     * @internal
     * Sets payment_schedule
     * @param \Orbipay\PaymentsApi\Client\Wrappers\PaymentSchedule $payment_schedule payment_schedule
     * @return $this
     */
    public function setPaymentSchedule($payment_schedule)
    {
        $this->payment_schedule = $payment_schedule;

        return $this;
    }

    /**
     * @internal
     * Sets payment_setup_entry_date
     * @param string $payment_setup_entry_date The date on which the payment setup is captured in Orbipay. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     * @return $this
     */
    public function setPaymentSetupEntryDate($payment_setup_entry_date)
    {
        $this->payment_setup_entry_date = $payment_setup_entry_date;

        return $this;
    }

    /**
     * @internal
     * Sets comments
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     * @return $this
     */
    public function setComments($comments)
    {
        $this->comments = $comments;

        return $this;
    }

    /**
     * @internal
     * Sets deleted
     * @param string $deleted The status of payment which says whether the payment is deleted or not
     * @return $this
     */
    public function setDeleted($deleted)
    {
        $this->deleted = $deleted;

        return $this;
    }

    /**
     * @internal
     * Sets customer
     * @param \Orbipay\PaymentsApi\Client\Wrappers\Customer $customer customer
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->customer = $customer;

        return $this;
    }

    /**
     * @internal
     * Sets funding_account
     * @param \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount $funding_account funding_account
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->funding_account = $funding_account;

        return $this;
    }

    /**
     * @internal
     * Sets customer_account
     * @param \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount $customer_account customer_account
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->customer_account = $customer_account;

        return $this;
    }

    /**
     * @internal
     * Sets payment_network_response
     * @param \Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse $payment_network_response payment_network_response
     * @return $this
     */
    public function setPaymentNetworkResponse($payment_network_response)
    {
        $this->payment_network_response = $payment_network_response;

        return $this;
    }

    /**
     * @internal
     * Sets audit_info
     * @param \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo $audit_info audit_info
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->audit_info = $audit_info;

        return $this;
    }

    /**
     * @internal
     * Sets id_customer
     * @param string $id_customer The unique identifier assigned by EBPP to the customer.
     * @return $this
     */
    public function setIdCustomer($id_customer)
    {
        $this->id_customer = $id_customer;

        return $this;
    }

    /**
     * @internal
     * Sets id_payment_setup
     * @param string $id_payment_setup The unique identifier assigned by EBPP to the payment setup.
     * @return $this
     */
    public function setIdPaymentSetup($id_payment_setup)
    {
        $this->id_payment_setup = $id_payment_setup;

        return $this;
    }

    /**
     * @var string 
     * $id The unique identifier assigned by Orbipay to the payment setup.
     */
    private $id;
  
     /**
     * Gets id
     *
     * @return string $id The unique identifier assigned by Orbipay to the payment setup.
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * @var string 
     * $url This URL fetches the details of payment setup.
     */
    private $url;
  
     /**
     * Gets url
     *
     * @return string $url This URL fetches the details of payment setup.
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\Fee 
     * $fee fee
     */
    private $fee;
  
     /**
     * Gets fee
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\Fee $fee fee
     */
    public function getFee()
    {
        return $this->fee;
    }
        
   /**
     * @var string $status The status of the payment.
     */
    private $status;
    
    /**
     * Gets status
     *
     * @return string $status The status of the payment.
     */

    public function getStatus()
    {
        return $this->status;
    }
    
        
   /**
     * @var string $payment_method The fulfillment method for the payment.
     */
    private $payment_method;
    
    /**
     * Gets payment_method
     *
     * @return string $payment_method The fulfillment method for the payment.
     */

    public function getPaymentMethod()
    {
        return $this->payment_method;
    }
    
        
   /**
     * @var string $payment_setup_schedule_type The schedule type for the payment setup.
     */
    private $payment_setup_schedule_type;
    
    /**
     * Gets payment_setup_schedule_type
     *
     * @return string $payment_setup_schedule_type The schedule type for the payment setup.
     */

    public function getPaymentSetupScheduleType()
    {
        return $this->payment_setup_schedule_type;
    }
    
    /**
     * @var string 
     * $confirmation_number The confirmation number or reference provided to the customer for the payment setup.
     */
    private $confirmation_number;
  
     /**
     * Gets confirmation_number
     *
     * @return string $confirmation_number The confirmation number or reference provided to the customer for the payment setup.
     */
    public function getConfirmationNumber()
    {
        return $this->confirmation_number;
    }
    /**
     * @var map[string,string] 
     * $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in Orbipay, would be accepted in the requests.
     */
    private $custom_fields;
  
     /**
     * Gets custom_fields
     *
     * @return map[string,string] $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in Orbipay, would be accepted in the requests.
     */
    public function getCustomFields()
    {
        return $this->custom_fields;
    }
    /**
     * @var string 
     * $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by Orbipay. This defaults to USD.
     */
    private $currency_code3d;
  
     /**
     * Gets currency_code3d
     *
     * @return string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by Orbipay. This defaults to USD.
     */
    public function getCurrencyCode3d()
    {
        return $this->currency_code3d;
    }
    /**
     * @var string 
     * $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     */
    private $amount;
  
     /**
     * Gets amount
     *
     * @return string $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     */
    public function getAmount()
    {
        return $this->amount;
    }
    /**
     * @var string 
     * $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment setup with a card funding account.
     */
    private $card_cvv_number;
  
     /**
     * Gets card_cvv_number
     *
     * @return string $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment setup with a card funding account.
     */
    public function getCardCvvNumber()
    {
        return $this->card_cvv_number;
    }
    /**
     * @var string 
     * $next_payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     */
    private $next_payment_date;
  
     /**
     * Gets next_payment_date
     *
     * @return string $next_payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     */
    public function getNextPaymentDate()
    {
        return $this->next_payment_date;
    }
    /**
     * @var string 
     * $payment_setup_reference The unique identifier in the client system for the payment setup.
     */
    private $payment_setup_reference;
  
     /**
     * Gets payment_setup_reference
     *
     * @return string $payment_setup_reference The unique identifier in the client system for the payment setup.
     */
    public function getPaymentSetupReference()
    {
        return $this->payment_setup_reference;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\PaymentSchedule 
     * $payment_schedule payment_schedule
     */
    private $payment_schedule;
  
     /**
     * Gets payment_schedule
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\PaymentSchedule $payment_schedule payment_schedule
     */
    public function getPaymentSchedule()
    {
        return $this->payment_schedule;
    }
    /**
     * @var string 
     * $payment_setup_entry_date The date on which the payment setup is captured in Orbipay. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     */
    private $payment_setup_entry_date;
  
     /**
     * Gets payment_setup_entry_date
     *
     * @return string $payment_setup_entry_date The date on which the payment setup is captured in Orbipay. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     */
    public function getPaymentSetupEntryDate()
    {
        return $this->payment_setup_entry_date;
    }
    /**
     * @var string 
     * $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     */
    private $comments;
  
     /**
     * Gets comments
     *
     * @return string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     */
    public function getComments()
    {
        return $this->comments;
    }
    /**
     * @var string 
     * $deleted The status of payment which says whether the payment is deleted or not
     */
    private $deleted;
  
     /**
     * Gets deleted
     *
     * @return string $deleted The status of payment which says whether the payment is deleted or not
     */
    public function getDeleted()
    {
        return $this->deleted;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\Customer 
     * $customer customer
     */
    private $customer;
  
     /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\Customer $customer customer
     */
    public function getCustomer()
    {
        return $this->customer;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount 
     * $funding_account funding_account
     */
    private $funding_account;
  
     /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount $funding_account funding_account
     */
    public function getFundingAccount()
    {
        return $this->funding_account;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount 
     * $customer_account customer_account
     */
    private $customer_account;
  
     /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount $customer_account customer_account
     */
    public function getCustomerAccount()
    {
        return $this->customer_account;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse 
     * $payment_network_response payment_network_response
     */
    private $payment_network_response;
  
     /**
     * Gets payment_network_response
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse $payment_network_response payment_network_response
     */
    public function getPaymentNetworkResponse()
    {
        return $this->payment_network_response;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo 
     * $audit_info audit_info
     */
    private $audit_info;
  
     /**
     * Gets audit_info
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo $audit_info audit_info
     */
    public function getAuditInfo()
    {
        return $this->audit_info;
    }
    /**
     * @var string 
     * $id_customer The unique identifier assigned by EBPP to the customer.
     */
    private $id_customer;
  
     /**
     * Gets id_customer
     *
     * @return string $id_customer The unique identifier assigned by EBPP to the customer.
     */
    public function getIdCustomer()
    {
        return $this->id_customer;
    }
    /**
     * @var string 
     * $id_payment_setup The unique identifier assigned by EBPP to the payment setup.
     */
    private $id_payment_setup;
  
     /**
     * Gets id_payment_setup
     *
     * @return string $id_payment_setup The unique identifier assigned by EBPP to the payment setup.
     */
    public function getIdPaymentSetup()
    {
        return $this->id_payment_setup;
    }

    
     /**
     * PaymentSetup constructor.
     * @param string $id_payment_setup 
     */
    public function __construct($id_payment_setup = null)
    {
        $this->id_payment_setup = $id_payment_setup;
		$this->id = $id_payment_setup;
    }
       
    public function forClient($client_key = null)
    {
		parent::forClient($client_key);
        
        return $this; 
    }
    public function videChannel($channel = null)
    {
		parent::videChannel($channel);
        
        return $this; 
    }
    public function withDetails($amount = null, $card_cvv_number = null, $payment_setup_schedule_type = null)
    {
        			$this->amount = $amount;
        		
        

        			$this->card_cvv_number = $card_cvv_number;
        		
        

        			$this->payment_setup_schedule_type = $payment_setup_schedule_type;
        		
        

        
        return $this; 
    }
    public function fromAccount($funding_account = null)
    {
        			$this->funding_account = $funding_account;
        		
        

        
        return $this; 
    }
    public function toAccount($customer_account = null)
    {
        			$this->customer_account = $customer_account;
        		
        

        
        return $this; 
    }
    public function withReference($payment_setup_reference = null)
    {
        			$this->payment_setup_reference = $payment_setup_reference;
        		
        

        
        return $this; 
    }
    public function withPaymentSchedule($payment_schedule = null)
    {
        			$this->payment_schedule = $payment_schedule;
        		
        

        
        return $this; 
    }
    public function withStatus($status = null)
    {
        			$this->status = $status;
        		
        

        
        return $this; 
    }
    public function withCustomFields($custom_fields = null)
    {
				if(isset($custom_fields)){
					if(count($custom_fields) == 0){
						$this->custom_fields = null;
					}
					else{
        				$this->custom_fields = $custom_fields;
					}
        		}else{
        			$this->custom_fields = $custom_fields;
        		}
        		
        

        
        return $this; 
    }
    public function withMemo($comments = null)
    {
        			$this->comments = $comments;
        		
        

        
        return $this; 
    }
    public function withFee($fee = null)
    {
        			$this->fee = $fee;
        		
        

        
        return $this; 
    }
    public function forCustomer($id_customer = null)
    {
        			$this->id_customer = $id_customer;
        		
        
	    $jsonArray = null;
	  	if($this->customer != null) {
		  	$serializedObject=ObjectSerializer::sanitizeForSerialization($this->customer);
	        $encodedString = json_encode($serializedObject);
	        $jsonArray = json_decode($encodedString,true);
		  	$jsonArray["id"] = $id_customer;
	  	}
	  	else {
	  		$jsonArray["id"] = $id_customer;
	  	}
	  	 $encodedJsonArray = json_encode($jsonArray);
	  	$this->customer =  ObjectSerializer::deserialize(json_decode($encodedJsonArray),'\Orbipay\PaymentsApi\Client\Wrappers\Customer',null);

        
        return $this; 
    }
    
	/**
     * createdBy
     *
     * @param $requestor
     * @param $requestor_type
     * @return PaymentSetup
     */
    public function createdBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

	/**
     * deletedBy
     *
     * @param $requestor
     * @param $requestor_type
     * @return PaymentSetup
     */
    public function deletedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

	/**
     * retrievedBy
     *
     * @param $requestor
     * @param $requestor_type
     * @return PaymentSetup
     */
    public function retrievedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

	/**
     * updatedBy
     *
     * @param $requestor
     * @param $requestor_type
     * @return PaymentSetup
     */
    public function updatedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    
	/**
     * create
     *
     * @param InvocationContext $invocationContext
     * @param string $liveMode
     * @param string $apiEndPoint
     * @return PaymentSetup
     * @throws OrbipayApiException
     */
    public function create(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\CreateRecurringPaymentSetupHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
	/**
     * delete
     *
     * @param InvocationContext $invocationContext
     * @param string $liveMode
     * @param string $apiEndPoint
     * @return PaymentSetup
     * @throws OrbipayApiException
     */
    public function delete(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\DeletePaymentSetupHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
	/**
     * get
     *
     * @param InvocationContext $invocationContext
     * @param string $liveMode
     * @param string $apiEndPoint
     * @return PaymentSetup
     * @throws OrbipayApiException
     */
    public function get(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\GetPaymentSetupHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
	/**
     * update
     *
     * @param InvocationContext $invocationContext
     * @param string $liveMode
     * @param string $apiEndPoint
     * @return PaymentSetup
     * @throws OrbipayApiException
     */
    public function update(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\UpdatePaymentSetupHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) , parent::jsonSerialize());
    }
}


