<?php

/**
 * RecordedPayments
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */



/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * RecordedPayments Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */
class RecordedPayments  extends Base 
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'list' => '\Orbipay\PaymentsApi\Client\Wrappers\RecordedPayment[]', 
        'total_results_count' => 'string', 
        'has_more_results' => 'string', 
        'url' => 'string', 
        'from_index' => 'string', 
        'to_index' => 'string', 
        'query_id' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'list' => null,
        'total_results_count' => null,
        'has_more_results' => null,
        'url' => null,
        'from_index' => null,
        'to_index' => null,
        'query_id' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'list' => 'list',
        'total_results_count' => 'total_results_count',
        'has_more_results' => 'has_more_results',
        'url' => 'url',
        'from_index' => 'from_index',
        'to_index' => 'to_index',
        'query_id' => 'query_id'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'list' => 'setList',
        'total_results_count' => 'setTotalResultsCount',
        'has_more_results' => 'setHasMoreResults',
        'url' => 'setUrl',
        'from_index' => 'setFromIndex',
        'to_index' => 'setToIndex',
        'query_id' => 'setQueryId'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'list' => 'getList',
        'total_results_count' => 'getTotalResultsCount',
        'has_more_results' => 'getHasMoreResults',
        'url' => 'getUrl',
        'from_index' => 'getFromIndex',
        'to_index' => 'getToIndex',
        'query_id' => 'getQueryId'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets list
     * @param \Orbipay\PaymentsApi\Client\Wrappers\RecordedPayment[] $list list
     * @return $this
     */
    public function setList($list)
    {
        $this->list = $list;

        return $this;
    }

    /**
     * @internal
     * Sets total_results_count
     * @param string $total_results_count total number of payments available with matching criteria
     * @return $this
     */
    public function setTotalResultsCount($total_results_count)
    {
        $this->total_results_count = $total_results_count;

        return $this;
    }

    /**
     * @internal
     * Sets has_more_results
     * @param string $has_more_results true if there are more results or pages
     * @return $this
     */
    public function setHasMoreResults($has_more_results)
    {
        $this->has_more_results = $has_more_results;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the next or previous set of payments, based on the presence of after_object or before_object parameter.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets from_index
     * @param string $from_index The id of the object before which the previous set of objects are to be retrieved.
     * @return $this
     */
    public function setFromIndex($from_index)
    {
        $this->from_index = $from_index;

        return $this;
    }

    /**
     * @internal
     * Sets to_index
     * @param string $to_index The id of the object after which the next set of objects are to be retrieved.
     * @return $this
     */
    public function setToIndex($to_index)
    {
        $this->to_index = $to_index;

        return $this;
    }

    /**
     * @internal
     * Sets query_id
     * @param string $query_id The query id of the object.
     * @return $this
     */
    public function setQueryId($query_id)
    {
        $this->query_id = $query_id;

        return $this;
    }

    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\RecordedPayment[] 
     * $list list
     */
    private $list;
  
     /**
     * Gets list
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\RecordedPayment[] $list list
     */
    public function getList()
    {
        return $this->list;
    }
    /**
     * @var string 
     * $total_results_count total number of payments available with matching criteria
     */
    private $total_results_count;
  
     /**
     * Gets total_results_count
     *
     * @return string $total_results_count total number of payments available with matching criteria
     */
    public function getTotalResultsCount()
    {
        return $this->total_results_count;
    }
        
   /**
     * @var string $has_more_results true if there are more results or pages
     */
    private $has_more_results;
    
    /**
     * Gets has_more_results
     *
     * @return string $has_more_results true if there are more results or pages
     */

    public function getHasMoreResults()
    {
        return $this->has_more_results;
    }
    
    /**
     * @var string 
     * $url This URL fetches the next or previous set of payments, based on the presence of after_object or before_object parameter.
     */
    private $url;
  
     /**
     * Gets url
     *
     * @return string $url This URL fetches the next or previous set of payments, based on the presence of after_object or before_object parameter.
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * @var string 
     * $from_index The id of the object before which the previous set of objects are to be retrieved.
     */
    private $from_index;
  
     /**
     * Gets from_index
     *
     * @return string $from_index The id of the object before which the previous set of objects are to be retrieved.
     */
    public function getFromIndex()
    {
        return $this->from_index;
    }
    /**
     * @var string 
     * $to_index The id of the object after which the next set of objects are to be retrieved.
     */
    private $to_index;
  
     /**
     * Gets to_index
     *
     * @return string $to_index The id of the object after which the next set of objects are to be retrieved.
     */
    public function getToIndex()
    {
        return $this->to_index;
    }
    /**
     * @var string 
     * $query_id The query id of the object.
     */
    private $query_id;
  
     /**
     * Gets query_id
     *
     * @return string $query_id The query id of the object.
     */
    public function getQueryId()
    {
        return $this->query_id;
    }

    
       
    public function forClient($client_key = null)
    {
		parent::forClient($client_key);
        
        return $this; 
    }
    public function videChannel($channel = null)
    {
		parent::videChannel($channel);
        
        return $this; 
    }
    public function findBy(MultiMap $filterMap = null)
    {
        
        
		$from_index_values = $filterMap->get('from_index');
		if ($from_index_values !== null && count($from_index_values) > 0) {
        	$this->from_index = end($from_index_values);
		}
        
        
		$to_index_values = $filterMap->get('to_index');
		if ($to_index_values !== null && count($to_index_values) > 0) {
        	$this->to_index = end($to_index_values);
		}
        
        
		$query_id_values = $filterMap->get('query_id');
		if ($query_id_values !== null && count($query_id_values) > 0) {
        	$this->query_id = end($query_id_values);
		}
        
        return $this; 
    }
    public function forCustomer()
    {
        
        return $this; 
    }
    
    
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) , parent::jsonSerialize());
    }
}


