<?php

/**
 * SourcePayment
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */



/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * SourcePayment Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */
class SourcePayment  
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'string', 
        'url' => 'string', 
        'customer' => '\Orbipay\PaymentsApi\Client\Wrappers\Customer', 
        'customer_account' => '\Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount', 
        'funding_account' => '\Orbipay\PaymentsApi\Client\Wrappers\FundingAccount'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'id' => null,
        'url' => null,
        'customer' => null,
        'customer_account' => null,
        'funding_account' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'url' => 'url',
        'customer' => 'customer',
        'customer_account' => 'customer_account',
        'funding_account' => 'funding_account'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'url' => 'setUrl',
        'customer' => 'setCustomer',
        'customer_account' => 'setCustomerAccount',
        'funding_account' => 'setFundingAccount'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'url' => 'getUrl',
        'customer' => 'getCustomer',
        'customer_account' => 'getCustomerAccount',
        'funding_account' => 'getFundingAccount'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets id
     * @param string $id id
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the details of source payment.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets customer
     * @param \Orbipay\PaymentsApi\Client\Wrappers\Customer $customer customer
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->customer = $customer;

        return $this;
    }

    /**
     * @internal
     * Sets customer_account
     * @param \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount $customer_account customer_account
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->customer_account = $customer_account;

        return $this;
    }

    /**
     * @internal
     * Sets funding_account
     * @param \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount $funding_account funding_account
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->funding_account = $funding_account;

        return $this;
    }

    /**
     * @var string 
     * $id id
     */
    private $id;
  
     /**
     * Gets id
     *
     * @return string $id id
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * @var string 
     * $url This URL fetches the details of source payment.
     */
    private $url;
  
     /**
     * Gets url
     *
     * @return string $url This URL fetches the details of source payment.
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\Customer 
     * $customer customer
     */
    private $customer;
  
     /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\Customer $customer customer
     */
    public function getCustomer()
    {
        return $this->customer;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount 
     * $customer_account customer_account
     */
    private $customer_account;
  
     /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount $customer_account customer_account
     */
    public function getCustomerAccount()
    {
        return $this->customer_account;
    }
    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount 
     * $funding_account funding_account
     */
    private $funding_account;
  
     /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount $funding_account funding_account
     */
    public function getFundingAccount()
    {
        return $this->funding_account;
    }

    
       
    
    
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) );
    }
}


